/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.cenarios.view;

import br.com.flaviobarros.simuladordeinvestimentos.cenarios.model.AbstractTableModelCenarios;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.controller.GerenciaArmazenamentoInvestimentos;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.indices.controller.GerenciaArmazenamentoIndices;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.indices.model.Indice;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.Investimento;
import br.com.flaviobarros.simuladordeinvestimentos.padroes.Padronizacoes;
import java.util.List;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

/**
 *
 * @author flavio
 */
public class CenariosView extends javax.swing.JPanel {

    private final JFrame janelaMae;
    private AbstractTableModelCenarios model;
    private JTable tabela;
    private boolean cenarioEmEdicao;

    public CenariosView(JFrame janelaMae) {

        initComponents(); // método padrão de inicialização dos JavaSwing (criado automaticamente)
        inicializaComponentes(); // método de inicialização dos componentes da janela (criado manualmente)

        this.cenarioEmEdicao = false;
        this.janelaMae = janelaMae;
    }

    private void inicializaComponentes() {
        initTabela();
        initBotoes();
        setDadosTabela(pesquisa());
        setFontes();
    }

    private void initTabela() {
        this.model = new AbstractTableModelCenarios();
        this.tabela = new JTable();
        this.tabela.setModel(model);
        this.jspCenarios.setViewportView(this.tabela);
        this.tabela.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        
        // definindo a larguras maximas/minimas das colunas das colunas 
        this.tabela.getColumnModel().getColumn(0).setMinWidth(100);
        this.tabela.getColumnModel().getColumn(1).setMinWidth(70);
        this.tabela.getColumnModel().getColumn(2).setMinWidth(70);
        this.tabela.getColumnModel().getColumn(3).setMinWidth(70);
        this.tabela.getColumnModel().getColumn(4).setMinWidth(70);
        this.tabela.getColumnModel().getColumn(5).setMinWidth(70);
        this.tabela.getColumnModel().getColumn(6).setMinWidth(70);
        this.tabela.getColumnModel().getColumn(1).setMaxWidth(150);
        this.tabela.getColumnModel().getColumn(2).setMaxWidth(150);
        this.tabela.getColumnModel().getColumn(3).setMaxWidth(150);
        this.tabela.getColumnModel().getColumn(4).setMaxWidth(150);
        this.tabela.getColumnModel().getColumn(5).setMaxWidth(150);
        this.tabela.getColumnModel().getColumn(6).setMaxWidth(150);
        
        // centralizando conteudo das colunas CENÁRIOS
        DefaultTableCellRenderer cellRender = new DefaultTableCellRenderer();
	cellRender.setHorizontalAlignment(SwingConstants.CENTER);
        this.tabela.getColumnModel().getColumn(1).setCellRenderer(cellRender);
        this.tabela.getColumnModel().getColumn(2).setCellRenderer(cellRender);
        this.tabela.getColumnModel().getColumn(3).setCellRenderer(cellRender);
        this.tabela.getColumnModel().getColumn(4).setCellRenderer(cellRender);
        this.tabela.getColumnModel().getColumn(5).setCellRenderer(cellRender);
        this.tabela.getColumnModel().getColumn(6).setCellRenderer(cellRender);
        

    }

    private void initBotoes() {
        this.jbCancelarEdicao.setVisible(false);
    }

//    private void ligaListenersCenario() {
//
//    }
    private List<Investimento> pesquisa() {

        GerenciaArmazenamentoInvestimentos gerenciaArmazenamentoInvestimentos = new GerenciaArmazenamentoInvestimentos();
        List lista = gerenciaArmazenamentoInvestimentos.getRegistrosDeTodosOsInvestimentos();

        return lista;
    }

    private void setDadosTabela(List<Investimento> objetos) {
        model.setDados(objetos);
//        this.ligaListenersCenario(); 
    }

    private void atualizaTabela() {
        setDadosTabela(pesquisa());
    }

    private void setFontes() {
        this.jspCenarios.setFont(Padronizacoes.getFontePadrao());
        this.jbCancelarEdicao.setFont(Padronizacoes.getFontePadrao());
        this.jbEditarCenario.setFont(Padronizacoes.getFontePadrao());
        this.jLabel1.setFont(Padronizacoes.getFontePadraoNegritoPequena());
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jspCenarios = new javax.swing.JScrollPane();
        jbCancelarEdicao = new javax.swing.JButton();
        jbEditarCenario = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        jspCenarios.setBorder(javax.swing.BorderFactory.createTitledBorder("CENÁRIOS"));

        jbCancelarEdicao.setText("Cancelar Edição");
        jbCancelarEdicao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbCancelarEdicaoActionPerformed(evt);
            }
        });

        jbEditarCenario.setText("Editar Cenário");
        jbEditarCenario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbEditarCenarioActionPerformed(evt);
            }
        });

        jLabel1.setText("Valores cenários em % ao ano.");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jspCenarios)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 564, Short.MAX_VALUE)
                        .addComponent(jbCancelarEdicao)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbEditarCenario)))
                .addGap(10, 10, 10))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel1)
                .addGap(150, 150, 150))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jbCancelarEdicao, jbEditarCenario});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(jLabel1)
                .addGap(0, 0, 0)
                .addComponent(jspCenarios, javax.swing.GroupLayout.DEFAULT_SIZE, 220, Short.MAX_VALUE)
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jbEditarCenario)
                    .addComponent(jbCancelarEdicao))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jbEditarCenarioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbEditarCenarioActionPerformed

        if (cenarioEmEdicao) { // caso o cenário esteja em edição o botão foi pressionado
            //para salvamento dos dados editados.

            // salva os dados dos índices
            persisteOuAtualizaIndices(this.model.getDadosIndices());
            
            if (persisteCenario(this.model.getDadosInvestimentos())) { // caso os dados tenham sido salvos com sucesso
                
                JOptionPane.showMessageDialog(this.janelaMae, "Dados dos cenários salvos com sucesso!");

            } else { // caso tenha ocorrido erro no salvamento dos dados

                JOptionPane.showMessageDialog(this.janelaMae, "Erro ao salvar os dados dos cenários!");

            }

            // caso os dados tenham sido salvos com sucesso
            this.jbCancelarEdicao.setVisible(false);
            this.jbEditarCenario.setText("Editar Cenário");
            this.model.desabilitaEdicao();
            this.cenarioEmEdicao = false;

        } else { // botão pressionado para o ínicio da edição dos dados do cenário
            this.jbCancelarEdicao.setVisible(true);
            this.jbEditarCenario.setText("Salvar Edição");
            this.model.habilitaEdicao();
            this.cenarioEmEdicao = true;
        }


    }//GEN-LAST:event_jbEditarCenarioActionPerformed

    private void jbCancelarEdicaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbCancelarEdicaoActionPerformed

        //restaurando os dados do cenário para o momento antes da edição
        this.atualizaTabela();

        // colocando a janela em modo de edição desabilitada
        this.jbCancelarEdicao.setVisible(false);
        this.jbEditarCenario.setText("Editar Cenário");
        this.model.desabilitaEdicao();
        this.cenarioEmEdicao = false;
    }//GEN-LAST:event_jbCancelarEdicaoActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JButton jbCancelarEdicao;
    private javax.swing.JButton jbEditarCenario;
    private javax.swing.JScrollPane jspCenarios;
    // End of variables declaration//GEN-END:variables

    private boolean persisteCenario(List<Investimento> dados) {

        GerenciaArmazenamentoInvestimentos gerenciaArmazenamento = new GerenciaArmazenamentoInvestimentos();

        return gerenciaArmazenamento.edita(dados);
    }

//  persisteOuAtualizaIndices(List<Indice> dados):  
//      - salva o(s) novo(s) índice ou atualiza os valores dos índices já cadastrados
    private void persisteOuAtualizaIndices(List<Indice> dados) {

//        boolean haveSelic;  // indica se há investimentos atrelados a Selic cadastrados
//        boolean haveCDI;    // indica se há investimentos atrelados ao CDI cadastrados
//        boolean haveTR;     // indica se há investimentos atrelados a TR cadastrados
//        boolean haveIPCA;   // indica se há investimentos atrelados ao IPCA cadastrados

        GerenciaArmazenamentoIndices gerenciaArmazenamento = new GerenciaArmazenamentoIndices();

        for (int i = 0; i < dados.size(); i++) {
            gerenciaArmazenamento.salvaOuAtualiza(dados.get(i));
        }
    }

}
