/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.cdb.controller;

import br.com.flaviobarros.simuladordeinvestimentos.investimentos.controller.ValidaInvestimento;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoCDB;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentosComunsSemelhantes;

/**
 *
 * @author flavio
 */
public class ValidaCDB{

    public static String valida(InvestimentoCDB entidade) {
        String erro = ValidaInvestimento.valida(entidade);

        if (entidade.getNome().isEmpty() || entidade.getNome() == null) {
            erro += "Insira o nome.\n";
        }
        
        if (entidade.getPrazoDoInvestimento() == null || entidade.getPrazoDoInvestimento() <= 0) {
            erro += "Informe o prazo máximo do investimento (em dias).\n";
        }
                        
        if (entidade.getCarenciaResgate() == null) {
            erro += "Informe a carência para resgate do investimento (em dias).\n";
        }
        
        if (entidade.getCarenciaResgate() != null && entidade.getPrazoDoInvestimento() != null) {
            if (entidade.getPrazoDoInvestimento() < entidade.getCarenciaResgate()) {
                erro += "Carência para resgate deve ser igual ou anterior ao prazo máximo do investimento.\n";
            }
        }
        
        if ((entidade.getPercentualCDIContratado() == null || entidade.getPercentualCDIContratado() <= 0) && entidade.getTipoDeRentabilidade() == InvestimentosComunsSemelhantes.TIPO_DE_RENTABILIDADE.POS_FIXADO) {
            erro += "Informe a rentabilidade contratada.\n";
        }
        
        if (entidade.getTipoDeRentabilidade() == null) {
            erro += "Informe a tipo de rentabilidade do investimento (pré-fixado ou pós-fixado).\n";
        }

        return erro;
    }

}

//        if (entidade.getTipo() == null) {
//            erro += "Selecione o tipo pessoa.\n";
//        }
//
//        if (entidade.getCpfCnpj().isEmpty()) {
//            erro += "Insira o cpf/cnpj.\n";
//        }