/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.controller;

import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.Investimento;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 *
 * @author flavio
 *
 */
public class GerenciaArmazenamentoInvestimentos {

    // OK!
    private boolean salva(Investimento entidade) {

        boolean retorno = false;
        Long lastId;
        List<Investimento> investimentos;

        try {
            investimentos = InvestimentosXML.load(entidade.getTipo()); // arquivo de persistencia de dados não encontrado/não cadastrado
        } catch (FileNotFoundException ex) {
            investimentos = new ArrayList<>();
        }

        // Obtendo id do ultimo investimento cadastrado cadastrado
        lastId = 0l;
        for (int i = 0; i < investimentos.size(); i++) {
            if (lastId < investimentos.get(i).getId()) {
                lastId = investimentos.get(i).getId();
            }
        }

        // setando o id da entidade
        entidade.setId(lastId + 1);

        // persistindo entidade
        investimentos.add(entidade);
        try {
            System.out.println("** ira persistir");
            InvestimentosXML.dump(investimentos, entidade.getTipo());
            retorno = true;
            System.out.println("** persistiu!");
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }

        return retorno;
    }

    // OK!
    private boolean edita(Investimento entidade) {

        List<Investimento> investimentos;
        boolean encontrado = false;
        boolean retorno = false;

        // carregando investimentos de mesmo tipo já cadastrados
        try {
            investimentos = InvestimentosXML.load(entidade.getTipo()); // arquivo de persistencia de dados não encontrado/não cadastrado
        } catch (FileNotFoundException ex) {
            investimentos = new ArrayList<>();
        }

        // buscando e alterando investimento
        for (int i = 0; i < investimentos.size(); i++) {
            // buscando entidade
            if (Objects.equals(investimentos.get(i).getId(), entidade.getId())) {
                investimentos.set(i, entidade);
                encontrado = true;
                break;
            }
        }

        // salvando entidade editada
        if (encontrado) {
            try {
                System.out.println("** ira persistir entidade editada");
                InvestimentosXML.dump(investimentos, entidade.getTipo());
                retorno = true;
                System.out.println("** persistiu entidade editada!");
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
            }
        }

        return retorno;
    }

    // Realiza o salvamento dos dados de investimentos editados em lote.
    // o retorno da função não esta sendo validado;
    public boolean edita(List<Investimento> entidades) {

        boolean retorno = false;
        
        ArrayList<Investimento> entidadesCDB = new ArrayList<>();
        ArrayList<Investimento> entidadesRDB = new ArrayList<>();
        ArrayList<Investimento> entidadesLCI = new ArrayList<>();
        ArrayList<Investimento> entidadesLCA = new ArrayList<>();
        ArrayList<Investimento> entidadesTesouroSelic = new ArrayList<>();
        ArrayList<Investimento> entidadesTesouroIPCA = new ArrayList<>();
        ArrayList<Investimento> entidadesFundos = new ArrayList<>();
        ArrayList<Investimento> entidadesPoupanca = new ArrayList<>();
        ArrayList<Investimento> entidadesPrevidencia = new ArrayList<>();

        // separando investimentos por tipo
        for (int i = 0; i < entidades.size(); i++) {
            if (entidades.get(i).isCDB()) {
                entidadesCDB.add(entidades.get(i));
            } else if (entidades.get(i).isRDB()) {
                entidadesRDB.add(entidades.get(i));
            } else if (entidades.get(i).isLCI()) {
                entidadesLCI.add(entidades.get(i));
            } else if (entidades.get(i).isLCA()) {
                entidadesLCA.add(entidades.get(i));
            } else if (entidades.get(i).isTesouroSelic()) {
                entidadesTesouroSelic.add(entidades.get(i));
            } else if (entidades.get(i).isTesouroIPCA()) {
                entidadesTesouroIPCA.add(entidades.get(i));
            } else if (entidades.get(i).isFundoDeInvestimento()) {
                entidadesFundos.add(entidades.get(i));
            } else if (entidades.get(i).isPoupanca()) {
                entidadesPoupanca.add(entidades.get(i));
            } else if (entidades.get(i).isPrevidencia()) {
                entidadesPrevidencia.add(entidades.get(i));
            }
        }
        
        if ( entidadesCDB.isEmpty() &&
                entidadesRDB.isEmpty() &&
                entidadesLCI.isEmpty() &&
                entidadesLCA.isEmpty() &&
                entidadesTesouroSelic.isEmpty() &&
                entidadesTesouroIPCA.isEmpty() &&
                entidadesFundos.isEmpty() &&
                entidadesPoupanca.isEmpty() &&
                entidadesPrevidencia.isEmpty()
                ) {
            retorno = true; // não há nenhum dado a ser salvo
        }
        
        
        // editando entidades por tipo
        if (entidadesCDB.isEmpty() == false) {
            retorno = edita(entidadesCDB, Investimento.TIPO.CDB);
        }
        
        if (entidadesRDB.isEmpty() == false) {
            retorno = edita(entidadesRDB, Investimento.TIPO.RDB);
        }
        
        if (entidadesLCI.isEmpty() == false) {
            retorno = edita(entidadesLCI, Investimento.TIPO.LCI);
        }
        
        if (entidadesLCA.isEmpty() == false) {
           retorno = edita(entidadesLCA, Investimento.TIPO.LCA);
        }
        
        if (entidadesTesouroSelic.isEmpty() == false) {
            retorno = edita(entidadesTesouroSelic, Investimento.TIPO.TESOURO_SELIC);
        }
        
        if (entidadesTesouroIPCA.isEmpty() == false) {
            retorno = edita(entidadesTesouroIPCA, Investimento.TIPO.TESOURO_IPCA);
        }
        
        if (entidadesFundos.isEmpty() == false) {
            retorno = edita(entidadesFundos, Investimento.TIPO.FUNDO_DE_INVESTIMENTO);
        }
        
        if (entidadesPoupanca.isEmpty() == false) {
            retorno = edita(entidadesPoupanca, Investimento.TIPO.POUPANCA);
        }
        
        if (entidadesPrevidencia.isEmpty() == false) {
            retorno = edita(entidadesPrevidencia, Investimento.TIPO.PREVIDENCIA);
        }
        
        return retorno;
    }

    /**
     * Realiza a edição de entidades em lotes de acordo com seu tipo
     *
     * @param entidades
     * @param tipo
     * @return
     */
    private boolean edita(List<Investimento> entidades, Investimento.TIPO tipo) {

        for (int i = 0; i < entidades.size(); i++) {
            if (entidades.get(i).getTipo() != tipo) {
                throw new IllegalArgumentException("Entidades recebidas como parâmetro possuem divergencia do tipo informado!");
            }
        }

        List<Investimento> investimentos;
        boolean encontrado = false;
        boolean retorno = false;

        // carregando investimentos de mesmo tipo já cadastrados
        try {
            investimentos = InvestimentosXML.load(tipo); // arquivo de persistencia de dados não encontrado/não cadastrado
        } catch (FileNotFoundException ex) {
            investimentos = new ArrayList<>();
        }

        // buscando e removendo investimentos a serem atualizados
        for (int i = 0; i < investimentos.size(); i++) {
            for (int j = 0; j < entidades.size(); j++) {
                if (Objects.equals(investimentos.get(i).getId(), entidades.get(j).getId())) {
                    investimentos.remove(i);
                    encontrado = true;
                    i--; // decrementandocontador devido a remoção
                    break;
                }
            }
        }

        // adicionando investimentos editados
        investimentos.addAll(entidades);

        // salvando entidades editada
        if (encontrado) {
            try {
                InvestimentosXML.dump(investimentos, tipo);
                retorno = true;
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
            }
        }

        return retorno;
    }

    public boolean remove(Investimento entidade) {

        List<Investimento> investimentos;
        boolean encontrado = false;
        boolean retorno = false;

        // carregando investimentos de mesmo tipo já cadastrados
        try {
            investimentos = InvestimentosXML.load(entidade.getTipo()); // arquivo de persistencia de dados não encontrado/não cadastrado
        } catch (FileNotFoundException ex) {
            investimentos = new ArrayList<>();
        }

        // buscando o investimento a ser removido
        for (int i = 0; i < investimentos.size(); i++) {
            // buscando entidade
            if (Objects.equals(investimentos.get(i).getId(), entidade.getId())) {
                investimentos.remove(i);
                encontrado = true;
                break;
            }
        }

        // salvando entidades após exclusão
        if (encontrado) {
            try {
                System.out.println("** ira remover");
                InvestimentosXML.dump(investimentos, entidade.getTipo());
                retorno = true;
                System.out.println("** removeu!");
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
            }
        }

        return retorno;
    }

    // OK!
    public Investimento pesquisa(Long id, Investimento.TIPO tipoDoInvestimento) {

        List<Investimento> investimentos;

        try {
            investimentos = InvestimentosXML.load(tipoDoInvestimento); // arquivo de persistencia de dados não encontrado/não cadastrado
        } catch (FileNotFoundException ex) {
            investimentos = new ArrayList<>();
        }

        for (int i = 0; i < investimentos.size(); i++) {
            if (Objects.equals(investimentos.get(i).getId(), id)) {
                return investimentos.get(i);
            }
        }

        return null;
    }

    // OK!
    public List<Investimento> getRegistrosDeTodosOsInvestimentos() {

        List<Investimento> registros;

        registros = getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.LCI);
        registros.addAll(getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.LCA));
        registros.addAll(getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.CDB));
        registros.addAll(getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.RDB));
        registros.addAll(getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.POUPANCA));
        registros.addAll(getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.TESOURO_IPCA));
        registros.addAll(getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.TESOURO_SELIC));
        registros.addAll(getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.FUNDO_DE_INVESTIMENTO));
        registros.addAll(getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO.PREVIDENCIA));

        return registros;
    }

    // OK!
    public List<Investimento> getRegistrosDeTipoDeInvestimentoEspecifico(Investimento.TIPO tipo_do_investimento) {

        ArrayList<Investimento> registros;

        try {
            //carrega os dados dos investimentos salvos (de acordo com o tipo recebido como parâmatro);
            registros = (ArrayList<Investimento>) InvestimentosXML.load(tipo_do_investimento);
        } catch (FileNotFoundException ex) {
            //O arquivo com os dados dos investimentos salvos não existe, ou não pode ser carregado.

            //carrega uma lista de clientes vazia
            registros = new ArrayList<>();
        }

        return registros;
    }

    // OK!
    public boolean salvaOuAtualiza(Investimento entidade) {
        if (entidade.getId() == 0L) {
            return this.salva(entidade);
        } else {
            return this.edita(entidade);
        }
    }

}
