/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.controller;

import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.Investimento;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoCDB;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoFundos;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoLCA;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoLCI;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoPoupanca;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoPrevidencia;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoRDB;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoTesouroIPCA;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoTesouroSelic;
import br.com.flaviobarros.simuladordeinvestimentos.padroes.Padronizacoes;
import br.com.flaviobarros.util.IOFile;
import com.thoughtworks.xstream.XStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author flavio
 */
public class InvestimentosXML {

    private static final String NOME_ARQUIVO_CDB = "investimento_cdb.xml";
    private static final String ALIAS_CDB = "investimento_cdb";

    private static final String NOME_ARQUIVO_RDB = "investimento_rdb.xml";
    private static final String ALIAS_RDB = "investimento_rdb";

    private static final String NOME_ARQUIVO_LCI = "investimento_lci.xml";
    private static final String ALIAS_LCI = "investimento_lci";

    private static final String NOME_ARQUIVO_LCA = "investimento_lca.xml";
    private static final String ALIAS_LCA = "investimento_lca";

    private static final String NOME_ARQUIVO_TESOURO_SELIC = "investimento_tesouro_selic.xml";
    private static final String ALIAS_TESOURO_SELIC = "investimento_tesouro_selic";

    private static final String NOME_ARQUIVO_TESOURO_IPCA = "investimento_tesouro_ipca.xml";
    private static final String ALIAS_TESOURO_IPCA = "investimento_tesouro_ipca";

    private static final String NOME_ARQUIVO_POUPANCA = "investimento_poupanca.xml";
    private static final String ALIAS_POUPANCA = "investimento_poupanca";

    private static final String NOME_ARQUIVO_FUNDOS = "investimento_fundos.xml";
    private static final String ALIAS_FUNDOS = "investimento_fundos";

    private static final String NOME_ARQUIVO_PREVIDENCIA = "investimento_previdencia.xml";
    private static final String ALIAS_PREVIDENCIA = "investimento_previdencia";

    // Lê os dados do arquivo xml com os dados do tipo de investimento em questão
    // e retorna uma lista dos investimentos armazenados com o tipo solicitado
    public static List<Investimento> load(Investimento.TIPO tipo) throws FileNotFoundException {

        if (tipo == null) {
            throw new IllegalArgumentException("Tipo de investimento recebido como parâmetro inválido!");
        }

        ArrayList<Investimento> investimentos = null;
        String xml;
        XStream xstream;

        if (tipo == Investimento.TIPO.CDB) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_CDB);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_CDB, InvestimentoCDB.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        } else if (tipo == Investimento.TIPO.RDB) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_RDB);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_RDB, InvestimentoRDB.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        } else if (tipo == Investimento.TIPO.LCI) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_LCI);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_LCI, InvestimentoLCI.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        } else if (tipo == Investimento.TIPO.LCA) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_LCA);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_LCA, InvestimentoLCA.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        } else if (tipo == Investimento.TIPO.TESOURO_SELIC) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_TESOURO_SELIC);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_TESOURO_SELIC, InvestimentoTesouroSelic.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        } else if (tipo == Investimento.TIPO.TESOURO_IPCA) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_TESOURO_IPCA);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_TESOURO_IPCA, InvestimentoTesouroIPCA.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        } else if (tipo == Investimento.TIPO.POUPANCA) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_POUPANCA);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_POUPANCA, InvestimentoPoupanca.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        } else if (tipo == Investimento.TIPO.FUNDO_DE_INVESTIMENTO) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_FUNDOS);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_FUNDOS, InvestimentoFundos.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        } else if (tipo == Investimento.TIPO.PREVIDENCIA) {

            // lendo arquivo xml com os dados do investimento
            xml = IOFile.load(getPath() + NOME_ARQUIVO_PREVIDENCIA);

            // criando stream
            xstream = new XStream();
            xstream.alias(ALIAS_PREVIDENCIA, InvestimentoPrevidencia.class);

            // carregando dados
            investimentos = (ArrayList) xstream.fromXML(xml);

        }

        return investimentos;
    }

    //Salva os dados da lista de clientes recebida como parâmetro em um arquivo xml.
    public static void dump(List<Investimento> investimentos, Investimento.TIPO tipo) throws FileNotFoundException {
        
        if (tipo == null) {
            throw new IllegalArgumentException("Tipo de investimento recebido como parâmetro inválido!");
        }
        
        String xml;
        String nomeArquivo;
        XStream xstream;
        
        
        xstream = new XStream();
        nomeArquivo = "";
        
        if (tipo == Investimento.TIPO.CDB){
            
            xstream.alias(ALIAS_CDB, InvestimentoCDB.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_CDB;
            
        } else if (tipo == Investimento.TIPO.RDB){
            
            xstream.alias(ALIAS_RDB, InvestimentoRDB.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_RDB;
            
        } else if (tipo == Investimento.TIPO.LCI){
            
            xstream.alias(ALIAS_LCI, InvestimentoLCI.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_LCI;
            
        } else if (tipo == Investimento.TIPO.LCA){
            
            xstream.alias(ALIAS_LCA, InvestimentoLCA.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_LCA;
            
        } else if (tipo == Investimento.TIPO.TESOURO_SELIC){
            
            xstream.alias(ALIAS_TESOURO_SELIC, InvestimentoTesouroSelic.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_TESOURO_SELIC;
            
        } else if (tipo == Investimento.TIPO.TESOURO_IPCA){
            
            xstream.alias(ALIAS_TESOURO_IPCA, InvestimentoTesouroIPCA.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_TESOURO_IPCA;
            
        } else if (tipo == Investimento.TIPO.POUPANCA){
            
            xstream.alias(ALIAS_POUPANCA, InvestimentoPoupanca.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_POUPANCA;
            
        } else if (tipo == Investimento.TIPO.FUNDO_DE_INVESTIMENTO){
            
            xstream.alias(ALIAS_FUNDOS, InvestimentoFundos.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_FUNDOS;
            
        } else if (tipo == Investimento.TIPO.PREVIDENCIA){
            
            xstream.alias(ALIAS_PREVIDENCIA, InvestimentoPrevidencia.class);
            nomeArquivo = getPath() + NOME_ARQUIVO_PREVIDENCIA;
            
        }

        xml = xstream.toXML(investimentos);
        
        IOFile.save(nomeArquivo, xml);
    }
    
    private static String getPath() {
        
        return Padronizacoes.getCaminhoArmazenamentoXML();
    }
}

