/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.fundos.view;

import br.com.flaviobarros.simuladordeinvestimentos.investimentos.controller.GerenciaArmazenamentoInvestimentos;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.fundos.controller.ValidaFundos;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoFundos;
import br.com.flaviobarros.simuladordeinvestimentos.padroes.Padronizacoes;
import br.com.flaviobarros.util.DocumentGenerico;
import java.awt.Window;
import javax.swing.JOptionPane;

/**
 *
 * @author flavio
 */
public final class FundosView extends javax.swing.JPanel {
        
    private final Window janelaMae;
    
    // CdbView(Window janelaMae)
    // * Window janelaMae: janela (Jframe ou JDialog) o qual este painel está contido (utilizado para o encerramento
    //      da janela de cadastro ao se concretizar a inserção/alteração de um investimento ou pressionar-se o botão
    //      cancelar.
    public FundosView(Window janelaMae) {
        
        this.janelaMae = janelaMae;
        
        initComponents();
        this.init();
    }
    
    // CdbView(Window janelaMae, InvestimentoFundos objetoJanela)
    // * Window janelaMae: janela (Jframe ou JDialog) o qual este painel está contido (utilizado para o encerramento
    //      da janela de cadastro ao se concretizar a inserção/alteração de um investimento ou pressionar-se o botão
    //      cancelar.
    // * InvestimentoFundos objetoJanela: Investimento a ser alterado.
    public FundosView(Window janelaMae, InvestimentoFundos objetoJanela) {
                
        this.janelaMae = janelaMae;
        
        initComponents();
        this.init();
        
        this.setObjetoJanela(objetoJanela);
    }
    
    private void init() {
        this.gerenciadorObjetoJanela = new GerenciaArmazenamentoInvestimentos();
        this.inicializaComponentes();
        this.setFontes();
        this.setEstadoJanela(ESTADO.NOVO);
        this.limpa();
    }

    
    private void inicializaComponentes() {
        //jtfNome
        jtfNome.setDocument(new DocumentGenerico(DocumentGenerico.TIPO.LIVRE, 60, true));
        
        inicializaComboBoxes();

    }

    private void limpa() {
        jtfNome.setText("");
        jcbTipoDeFundo.setSelectedItem(null);
    }

    private void exibeObjetoJanela() {
        if (this.objetoJanela != null) {

            //nome
            if (this.objetoJanela.getNome() != null) {
                jtfNome.setText(objetoJanela.getNome());
            } else {
                jtfNome.setText("");
            }
            
            //tipo
            if (this.objetoJanela.getTipodefundo()!= null) {
                jcbTipoDeFundo.setSelectedItem(objetoJanela.getTipodefundo());
            } else {
                jcbTipoDeFundo.setSelectedItem(null);
            }

        } else {
            limpa();
        }
    }

    
    private void carregaObjetoJanela() {
        if (this.objetoJanela == null) {
            this.objetoJanela = new InvestimentoFundos();
        }

        this.objetoJanela.setNome(jtfNome.getText());

        this.objetoJanela.setTipodefundo((InvestimentoFundos.TIPO_DE_FUNDO) jcbTipoDeFundo.getSelectedItem());
    }

    public InvestimentoFundos getObjetoJanela() {
        this.carregaObjetoJanela();
        return objetoJanela;
    }

    public void setObjetoJanela(InvestimentoFundos objetoJanela) {
        this.objetoJanela = objetoJanela;
        this.exibeObjetoJanela();
    }

    private void habilitaJanela(boolean estado) {
        jtfNome.setEditable(estado);
        jcbTipoDeFundo.setEnabled(estado);
    }

    private void habilita() {
        this.habilitaJanela(true);
    }

    public void desabilita() {
        this.habilitaJanela(false);
    }

    //controla o estao no qual a janela se encontra.
    //estes estados são modificados de acordo com o pressionamento dos botões.
    public void setEstadoJanela(ESTADO estado) {
        if (null != estado) switch (estado) {
            case NOVO:
                this.objetoJanela = new InvestimentoFundos();
                this.jbNovo.setText("NOVO");
                this.limpa();
                this.desabilita();
                break;
            case EDITAR:
                this.jbNovo.setText("EDITAR");
                this.desabilita();
                break;
            case SALVAR:
                this.jbNovo.setText("SALVAR");
                this.habilita();
                break;
            default:
                break;
        }

        this.estadoJanela = estado;
    }

    public ESTADO getEstadoJanela() {
        return estadoJanela;
    }

    private void setFontes() {
        jbCancelar.setFont(Padronizacoes.getFontePadrao());
        jbNovo.setFont(Padronizacoes.getFontePadrao());
        jLabel2.setFont(Padronizacoes.getFontePadrao());
        jLabel3.setFont(Padronizacoes.getFontePadrao());
        
        jPanel3.setFont(Padronizacoes.getFontePadrao());
        
        jtfNome.setFont(Padronizacoes.getFontePadrao());
        jcbTipoDeFundo.setFont(Padronizacoes.getFontePadrao());
    }

//    private void exibeCodigo(Long id) {
//        jtfCodigo.setText(id.toString());
//    }

    public enum ESTADO {

        NOVO,
        EDITAR,//este estado indica que existe um registro atualmente selecionado, 
               //mas não esta com a edição ativa (esta apenas em modo de visualização).
        SALVAR
    }

    private InvestimentoFundos objetoJanela;
    private ESTADO estadoJanela;
    private GerenciaArmazenamentoInvestimentos gerenciadorObjetoJanela;

    private void inicializaComboBoxes() {
        
        //inicializando combobox TipoRentabilidade
        jcbTipoDeFundo.addItem(null);
        jcbTipoDeFundo.addItem(InvestimentoFundos.TIPO_DE_FUNDO.CURTO_PRAZO);
        jcbTipoDeFundo.addItem(InvestimentoFundos.TIPO_DE_FUNDO.LONGO_PRAZO);
        jcbTipoDeFundo.addItem(InvestimentoFundos.TIPO_DE_FUNDO.ACOES);
        
    }

    // encerra a janela recebida como parâmetro (a qual,
    // deverá ser a janela no qual o frame está contido
    // para, por exemplo, o correto funcionamento do 
    // botão cancelar.
    private void closeJanelaMae() {
        this.janelaMae.dispose();
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnDados = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jtfNome = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jcbTipoDeFundo = new javax.swing.JComboBox();
        jpMensagem = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jbNovo = new javax.swing.JButton();
        jbCancelar = new javax.swing.JButton();

        setMinimumSize(new java.awt.Dimension(0, 0));
        setPreferredSize(new java.awt.Dimension(800, 500));

        pnDados.setPreferredSize(new java.awt.Dimension(800, 450));

        jLabel2.setText("Nome");

        jtfNome.setMinimumSize(new java.awt.Dimension(180, 27));

        jLabel3.setText("Tipo");

        jcbTipoDeFundo.setPreferredSize(new java.awt.Dimension(40, 19));
        jcbTipoDeFundo.setRequestFocusEnabled(false);

        javax.swing.GroupLayout jpMensagemLayout = new javax.swing.GroupLayout(jpMensagem);
        jpMensagem.setLayout(jpMensagemLayout);
        jpMensagemLayout.setHorizontalGroup(
            jpMensagemLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 358, Short.MAX_VALUE)
        );
        jpMensagemLayout.setVerticalGroup(
            jpMensagemLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 69, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout pnDadosLayout = new javax.swing.GroupLayout(pnDados);
        pnDados.setLayout(pnDadosLayout);
        pnDadosLayout.setHorizontalGroup(
            pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnDadosLayout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(jtfNome, javax.swing.GroupLayout.DEFAULT_SIZE, 549, Short.MAX_VALUE))
                .addGap(6, 6, 6)
                .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jcbTipoDeFundo, javax.swing.GroupLayout.PREFERRED_SIZE, 225, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addGap(10, 10, 10))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnDadosLayout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(jpMensagem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        pnDadosLayout.setVerticalGroup(
            pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnDadosLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(pnDadosLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addGap(0, 0, 0)
                        .addComponent(jcbTipoDeFundo, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pnDadosLayout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(0, 0, 0)
                        .addComponent(jtfNome, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(35, 35, 35)
                .addComponent(jpMensagem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(293, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel3.setPreferredSize(new java.awt.Dimension(800, 50));

        jbNovo.setText("SALVAR");
        jbNovo.setPreferredSize(new java.awt.Dimension(130, 25));
        jbNovo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbNovoActionPerformed(evt);
            }
        });

        jbCancelar.setText("CANCELAR");
        jbCancelar.setPreferredSize(new java.awt.Dimension(130, 25));
        jbCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jbNovo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jbCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jbNovo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jbCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(10, 10, 10))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(pnDados, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(pnDados, javax.swing.GroupLayout.DEFAULT_SIZE, 444, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jbNovoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbNovoActionPerformed
        if (this.estadoJanela == ESTADO.SALVAR) {
            InvestimentoFundos objeto = getObjetoJanela();
            String erro = ValidaFundos.valida(objeto);

            //caso todos os campos obrigatórios tenham sido preenchidos
            if (erro.isEmpty()) {
                String msg = "";
                if (gerenciadorObjetoJanela.salvaOuAtualiza(objeto)) {
                    msg += "Salvo com sucesso!";                  
//                    exibeCodigo(objeto.getId());
                    this.setEstadoJanela(ESTADO.EDITAR);
                    
                    // encerrando a janelaMãe após o salvamento da entidade em edição.
                    this.closeJanelaMae();
                    
                } else {
                    msg += "Erro no salvamento!";
                }
                
                JOptionPane.showMessageDialog(this, msg);
            } else {
                JOptionPane.showMessageDialog(this, erro);
            }
        } else {
            setEstadoJanela(ESTADO.SALVAR);
        }
    }//GEN-LAST:event_jbNovoActionPerformed

    private void jbCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbCancelarActionPerformed
        // encerrando a janelaMãe após o pressionamento do botão cancelar
        this.closeJanelaMae();
    }//GEN-LAST:event_jbCancelarActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JButton jbCancelar;
    private javax.swing.JButton jbNovo;
    private javax.swing.JComboBox jcbTipoDeFundo;
    private javax.swing.JPanel jpMensagem;
    private javax.swing.JTextField jtfNome;
    private javax.swing.JPanel pnDados;
    // End of variables declaration//GEN-END:variables
}
