/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.indices.controller;

import br.com.flaviobarros.simuladordeinvestimentos.investimentos.indices.model.Indice;
import br.com.flaviobarros.simuladordeinvestimentos.padroes.Padronizacoes;
import br.com.flaviobarros.util.IOFile;
import com.thoughtworks.xstream.XStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author flavio
 */
public class IndicesXML {
    
    private static final String NOME_ARQUIVO = "indices.xml";
    private static final String ALIAS = "indice";
    
    //Lê os dados do arquivo xml com os dados dos indices
    //e retorna uma lista de indices armazenados
    public static List<Indice> load() throws FileNotFoundException
    {
        ArrayList<Indice> entidades = null;
        
        //lendo arquivo xml com os dados dos Indices salvos
        String xml = IOFile.load(getPath() + NOME_ARQUIVO);

        // criando stream
        XStream xstream = new XStream();
        xstream.alias(ALIAS, Indice.class);

        // carregando dados
        entidades =(ArrayList) xstream.fromXML(xml);
        
        return entidades;
    }
    
    //Salva os dados da lista de indices recebida como parâmetro em um arquivo xml.
    public static void dump(List<Indice> indices) throws FileNotFoundException
    {
        XStream xstream = new XStream();
        
        xstream.alias(ALIAS, Indice.class);
        
        String xml = xstream.toXML(indices);
        
        IOFile.save(getPath() + NOME_ARQUIVO, xml);
    }
    
    private static String getPath() {
        return Padronizacoes.getCaminhoArmazenamentoXML();
    }
    
}
