/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.indices.model;

import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.CenariosInvestimentos;
import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

/**
 *
 * @author flavio
 */
@Entity
@Table(name="indice")
public class Indice extends CenariosInvestimentos implements Serializable{
    
//--- DEFINIÇÃO DE TIPOS -------------------------------------------------------
    public enum TIPO{
        CDI("CDI"),
        SELIC("Selic"),
        TR("TR"),
        IPCA("IPCA");
        //IBOVESPA("Ibovespa");        
        
        private final String descricao;

        private TIPO(String descricao) {
            this.descricao = descricao;
        }

        public String getDescricao() {
            return descricao;
        }
    }
    
    
    
//--- ATRIBUTOS ----------------------------------------------------------------
    @Id
    @GeneratedValue
    private Long id;
    
    //Tipo do indice
    @Column(nullable = false, unique = true)
    @Enumerated(EnumType.STRING)
    private TIPO tipo;
    
    private String nome;


    
//--- CONSTRUTOR ---------------------------------------------------------------
    public Indice(TIPO tipo) {
        super();
        this.id = 0l;
        this.tipo = tipo;
        this.nome = this.getTipo().getDescricao();
    }    
    
    public Indice() {
        super();
        this.id = 0l;
    } 
    
    
    
//--- MÉTODOS ------------------------------------------------------------------
    public String getDescricao() {
        return "\n   Tipo: "+this.getTipo().getDescricao()+"\n\n";
    }
    
    
    
//--- GETTERS AND SETTERS ------------------------------------------------------
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    public TIPO getTipo() {
        return tipo;
    }
    
    public String getNome() {
        return nome;
    }
    
    public void setNome(String nome) {
        this.nome = nome;
    }

    public void setTipo(TIPO tipo) {
        this.tipo = tipo;
        this.nome = getTipo().getDescricao();
    }
    

}
