/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.model;

import java.util.ArrayList;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author flavio
 */
public class AbstractTableModelInvestimentos extends AbstractTableModel {

    private List<Investimento> investimentos;
    private final String[] colunas;

    public AbstractTableModelInvestimentos() {
        this.investimentos = new ArrayList<>();
        this.colunas = new String[]{"Investimento","Editar","Excluir"};
    }

    @Override
    public String getColumnName(int column) {
        return this.colunas[column];
    }

    @Override
    public int getRowCount() {
        return investimentos.size();
    }

    @Override
    public int getColumnCount() {
        return colunas.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        switch (columnIndex) {
            case 0:
                return investimentos.get(rowIndex).getNome();
            case 1:
                return new String("Editar");
            case 2:
                return new String("Excluir");
        }
        return null;
    }

    @Override
    public Class<?> getColumnClass(int column) {
        return getValueAt(0, column).getClass();
    }

    public Investimento getInvestimento(int rowIndex) {
        return investimentos.get(rowIndex);
    }

    public void addRow(Investimento c) {
        this.investimentos.add(c);
        fireTableDataChanged();
    }

    public void setDados(List<Investimento> investimentos) {
        if (investimentos == null) {
            this.investimentos.clear();
        } else {
            this.investimentos = investimentos;
        }

        fireTableDataChanged();
    }
    
}
