/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.model;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Table;

/**
 *
 * @author flavio
 */
@Entity
@Table (name = "investimento_fundos")
public class InvestimentoFundos extends Investimento implements Serializable{
    
//--- DEFINIÇÂO DE TIPOS -------------------------------------------------------
    public enum TIPO_DE_FUNDO{
        LONGO_PRAZO("Longo Prazo"),
        CURTO_PRAZO("Curto Prazo"),
        ACOES("Ações");        
        
        private final String descricao;

        private TIPO_DE_FUNDO(String descricao) {
            this.descricao = descricao;
        }

        public String getDescricao() {
            return descricao;
        }
    }
    
    
    
//--- ATRIBUTOS ----------------------------------------------------------------
    //tipo do fundo de investimento (Classificado quanto a tributação do Imposto de Renda)
    @Column(nullable = false, name = "tipo_de_fundo")
    @Enumerated(EnumType.STRING)
    private TIPO_DE_FUNDO tipoDeFundo;

    
    
//-- CONSTRUTORES --------------------------------------------------------------
    //  construtor vazio devido ao uso do hibernate
    public InvestimentoFundos() {
        super("", TIPO.FUNDO_DE_INVESTIMENTO);
        this.tipoDeFundo = null;
    }

    public InvestimentoFundos(TIPO_DE_FUNDO tipo_de_fundo, String nome) {
        super(nome, Investimento.TIPO.FUNDO_DE_INVESTIMENTO);
        this.tipoDeFundo = tipo_de_fundo;
    }
    
    
    
//-- MÉTODOS -------------------------------------------------------------------
    @Override
    public String getDescricao() {
        String descricao;
        
        descricao = super.getDescricao();
        descricao += "   Tipo de fundo: "+getTipodefundo().getDescricao()+"\n\n";
        
        return  descricao;
    }
    
    @Override
    public String getDescricaoCompacta() {
        
        String descricao = "Nome: "+this.getNome()+"\n";
        descricao += "   Tipo: "+this.getTipo().getDescricao();
        descricao += ";  Tipo de fundo: "+getTipodefundo().getDescricao()+".";
        
        return descricao;
    }
    
//--- GETTERS AND SETTERS ------------------------------------------------------
    public TIPO_DE_FUNDO getTipodefundo() {
        return tipoDeFundo;
    }

    public void setTipodefundo(TIPO_DE_FUNDO tipo_de_fundo) {
        this.tipoDeFundo = tipo_de_fundo;
    }
    
    public boolean isFundoDeLongoPrazo() {
        return tipoDeFundo == TIPO_DE_FUNDO.LONGO_PRAZO;
    }
    
    public boolean isFundoDeCurtoPrazo() {
        return tipoDeFundo == TIPO_DE_FUNDO.CURTO_PRAZO;
    }
    
    public boolean isFundoDeAcoes() {
        return tipoDeFundo == TIPO_DE_FUNDO.ACOES;
    }
    
    
}
