/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.model;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 *
 * @author flavio
 */
@Entity
@Table (name = "investimento_lca")
public class InvestimentoLCA extends InvestimentosComunsSemelhantes implements Serializable{

//--- ATRIBUTOS ---------------------------------------------------------------- 
    @Column(nullable = false, name = "carencia_resgate")
    private Integer carenciaResgate;
    
    
    
//--- CONSTRUTORES -------------------------------------------------------------    
    public InvestimentoLCA(String nome) {
        super(nome, Investimento.TIPO.LCA);
        this.carenciaResgate = 0;
    }

    public InvestimentoLCA() {
        super("", Investimento.TIPO.LCA);
        this.carenciaResgate = 0;
    }
    
    
    
//--- MÉTODOS ------------------------------------------------------------------
    @Override
    public String getDescricao() {
        
        String descricao;
        
        descricao = "\n   Nome: "+this.getNome()+"\n\n";
        descricao += "   Tipo: "+this.getTipo().getDescricao()+"\n\n";
        descricao += "   Tipo de rentabilidade: "+getTipoDeRentabilidade().getDescricao()+"\n\n";
        
        if(getTipoDeRentabilidade() == InvestimentosComunsSemelhantes.TIPO_DE_RENTABILIDADE.POS_FIXADO){
            descricao += "   Rentabilidade: " + getPercentualCDIContratado();
            descricao += " % do CDI.\n\n";
        }
        
        descricao += "   Carência: " + this.getCarenciaResgate()+ " dias.\n\n";
        descricao += "   Prazo: " + this.getPrazoDoInvestimento() + " dias\n\n";
        
        return  descricao;
    }
    
    @Override
    public String getDescricaoCompacta() {
        
        String descricao = "Nome: "+this.getNome()+"\n"+
                            "   Tipo: "+this.getTipo().getDescricao()+
                            ";  Tipo de rentabilidade: "+this.getTipoDeRentabilidade().getDescricao();
                            
        if(getTipoDeRentabilidade() == InvestimentosComunsSemelhantes.TIPO_DE_RENTABILIDADE.POS_FIXADO){
            descricao += ";  Rentabilidade contratada: " + getPercentualCDIContratado();
            descricao += " % do CDI";
        }
        
        descricao += ";  Carência: "+ this.getCarenciaResgate() + " dias";
        descricao += ";  Prazo: "+ this.getPrazoDoInvestimento() + " dias.";
        
        
        return descricao;
    }

    
    
//-- GETTERS AND SETTERS -------------------------------------------------------
    public Integer getCarenciaResgate() {
        return carenciaResgate;
    }

    public void setCarenciaResgate(Integer carenciaResgate) {
        this.carenciaResgate = carenciaResgate;
    }
    
}
