/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.previdencia.view;

import br.com.flaviobarros.simuladordeinvestimentos.investimentos.controller.GerenciaArmazenamentoInvestimentos;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoPrevidencia;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.previdencia.controller.ValidaPrevidencia;
import br.com.flaviobarros.simuladordeinvestimentos.padroes.Padronizacoes;
import br.com.flaviobarros.util.DocumentGenerico;
import java.awt.Window;
import javax.swing.JOptionPane;

/**
 *
 * @author flavio
 */
public final class PrevidenciaView extends javax.swing.JPanel {
        
    private final Window janelaMae;
    
    // CdbView(Window janelaMae)
    // * Window janelaMae: janela (Jframe ou JDialog) o qual este painel está contido (utilizado para o encerramento
    //      da janela de cadastro ao se concretizar a inserção/alteração de um investimento ou pressionar-se o botão
    //      cancelar.
    public PrevidenciaView(Window janelaMae) {
        
        this.janelaMae = janelaMae;
        
        initComponents();
        this.init();
    }
    
    // CdbView(Window janelaMae, InvestimentoPrevidencia objetoJanela)
    // * Window janelaMae: janela (Jframe ou JDialog) o qual este painel está contido (utilizado para o encerramento
    //      da janela de cadastro ao se concretizar a inserção/alteração de um investimento ou pressionar-se o botão
    //      cancelar.
    // * InvestimentoPrevidencia objetoJanela: Investimento a ser alterado.
    public PrevidenciaView(Window janelaMae, InvestimentoPrevidencia objetoJanela) {
                
        this.janelaMae = janelaMae;
        
        initComponents();
        this.init();
        
        this.setObjetoJanela(objetoJanela);
    }
    
    private void init() {
        this.gerenciadorObjetoJanela = new GerenciaArmazenamentoInvestimentos();
        this.inicializaComponentes();
        this.setFontes();
        this.setEstadoJanela(ESTADO.NOVO);
        this.limpa();
    }

    
    private void inicializaComponentes() {
        //jtfNome
        jtfNome.setDocument(new DocumentGenerico(DocumentGenerico.TIPO.LIVRE, 60, true));
        jtfTaxaCarregamentoAntecipada.setDocument(new DocumentGenerico(DocumentGenerico.TIPO.NUMERICO_DECIMAL));
        jtfTaxaCarregamentoPostecipada.setDocument(new DocumentGenerico(DocumentGenerico.TIPO.NUMERICO_DECIMAL));
        jtfCarencia.setDocument(new DocumentGenerico(DocumentGenerico.TIPO.NUMERICO_INTEIRO));
        
        inicializaComboBoxes();

    }

    private void limpa() {
        jtfNome.setText("");
        jcbTipoPrevidencia.setSelectedItem(null);
        jcbTipoTributacao.setSelectedItem(null);
        jtfCarencia.setText("");
        jtfTaxaCarregamentoAntecipada.setText("0.00");
        jtfTaxaCarregamentoPostecipada.setText("0.00");
    }

    private void exibeObjetoJanela() {
        if (this.objetoJanela != null) {

            //nome
            if (this.objetoJanela.getNome() != null) {
                jtfNome.setText(objetoJanela.getNome());
            } else {
                jtfNome.setText("");
            }
            
            //tipo de plano (PGBL ou VGBL)
            if (this.objetoJanela.getTipoPrevidencia()!= null) {
                jcbTipoPrevidencia.setSelectedItem(objetoJanela.getTipoPrevidencia());
            } else {
                jcbTipoPrevidencia.setSelectedItem(null);
            }
            
            //tipo de tributação
            if (this.objetoJanela.getTributacaoPrevidencia()!= null) {
                jcbTipoTributacao.setSelectedItem(objetoJanela.getTributacaoPrevidencia());
            } else {
                jcbTipoTributacao.setSelectedItem(null);
            }
            
            //carência
            if (this.objetoJanela.getCarenciaResgate()!= null) {
                jtfCarencia.setText(objetoJanela.getCarenciaResgate().toString());
            } else {
                jtfCarencia.setText("");
            }
            
            if(this.objetoJanela.getTaxaDeCarregamentoAntecipada() != null) {
                jtfTaxaCarregamentoAntecipada.setText(this.objetoJanela.getTaxaDeCarregamentoAntecipada().toString());
            } else {
                jtfTaxaCarregamentoAntecipada.setText("0.00");
            }
            
            if(this.objetoJanela.getTaxaDeCarregamentoPostecipada() != null) {
                jtfTaxaCarregamentoPostecipada.setText(this.objetoJanela.getTaxaDeCarregamentoPostecipada().toString());
            } else {
                jtfTaxaCarregamentoPostecipada.setText("0.00");
            }

        } else {
            limpa();
        }
    }

    
    private void carregaObjetoJanela() {
        if (this.objetoJanela == null) {
            this.objetoJanela = new InvestimentoPrevidencia();
        }

        this.objetoJanela.setNome(jtfNome.getText());
        
        this.objetoJanela.setTipoPrevidencia((InvestimentoPrevidencia.TIPO_PREVIDENCIA) jcbTipoPrevidencia.getSelectedItem());
        
        this.objetoJanela.setTributacaoPrevidencia((InvestimentoPrevidencia.TRIBUTACAO_PREVIDENCIA) jcbTipoTributacao.getSelectedItem());
        
        if(!jtfCarencia.getText().isEmpty()) {
            this.objetoJanela.setCarenciaResgate(Integer.parseInt(jtfCarencia.getText()));
        } else {
            this.objetoJanela.setCarenciaResgate(null);
        }
        
        if (jtfTaxaCarregamentoAntecipada.getText() != null && !jtfTaxaCarregamentoAntecipada.getText().isEmpty()) {
            this.objetoJanela.setTaxaDeCarregamentoAntecipada(Double.parseDouble(jtfTaxaCarregamentoAntecipada.getText()));
        } else {
            this.objetoJanela.setTaxaDeCarregamentoAntecipada(null);
        }
        
        if (jtfTaxaCarregamentoPostecipada.getText() != null && !jtfTaxaCarregamentoPostecipada.getText().isEmpty()) {
            this.objetoJanela.setTaxaDeCarregamentoPostecipada(Double.parseDouble(jtfTaxaCarregamentoPostecipada.getText()));
        } else {
            this.objetoJanela.setTaxaDeCarregamentoPostecipada(null);
        }
        
    }

    public InvestimentoPrevidencia getObjetoJanela() {
        this.carregaObjetoJanela();
        return objetoJanela;
    }

    public void setObjetoJanela(InvestimentoPrevidencia objetoJanela) {
        this.objetoJanela = objetoJanela;
        this.exibeObjetoJanela();
    }

    private void habilitaJanela(boolean estado) {
        jtfNome.setEditable(estado);
        jcbTipoPrevidencia.setEnabled(estado);
    }

    private void habilita() {
        this.habilitaJanela(true);
    }

    public void desabilita() {
        this.habilitaJanela(false);
    }

    //controla o estao no qual a janela se encontra.
    //estes estados são modificados de acordo com o pressionamento dos botões.
    public void setEstadoJanela(ESTADO estado) {
        if (null != estado) switch (estado) {
            case NOVO:
                this.objetoJanela = new InvestimentoPrevidencia();
                this.jbNovo.setText("NOVO");
                this.limpa();
                this.desabilita();
                break;
            case EDITAR:
                this.jbNovo.setText("EDITAR");
                this.desabilita();
                break;
            case SALVAR:
                this.jbNovo.setText("SALVAR");
                this.habilita();
                break;
            default:
                break;
        }

        this.estadoJanela = estado;
    }

    public ESTADO getEstadoJanela() {
        return estadoJanela;
    }

    private void setFontes() {
        jbCancelar.setFont(Padronizacoes.getFontePadrao());
        jbNovo.setFont(Padronizacoes.getFontePadrao());
        jLabel1.setFont(Padronizacoes.getFontePadrao());
        jLabel2.setFont(Padronizacoes.getFontePadrao());
        jLabel3.setFont(Padronizacoes.getFontePadrao());
        jLabel4.setFont(Padronizacoes.getFontePadrao());
        jLabel5.setFont(Padronizacoes.getFontePadrao());
        jLabel9.setFont(Padronizacoes.getFontePadrao());
        
        jPanel3.setFont(Padronizacoes.getFontePadrao());
        
        jtfNome.setFont(Padronizacoes.getFontePadrao());
        jtfTaxaCarregamentoAntecipada.setFont(Padronizacoes.getFontePadrao());
        jtfTaxaCarregamentoPostecipada.setFont(Padronizacoes.getFontePadrao());
        jtfCarencia.setFont(Padronizacoes.getFontePadrao());
        
        jcbTipoPrevidencia.setFont(Padronizacoes.getFontePadrao());
        jcbTipoTributacao.setFont(Padronizacoes.getFontePadrao());
    }

//    private void exibeCodigo(Long id) {
//        jtfCodigo.setText(id.toString());
//    }

    public enum ESTADO {

        NOVO,
        EDITAR,//este estado indica que existe um registro atualmente selecionado, 
               //mas não esta com a edição ativa (esta apenas em modo de visualização).
        SALVAR
    }

    private InvestimentoPrevidencia objetoJanela;
    private ESTADO estadoJanela;
    private GerenciaArmazenamentoInvestimentos gerenciadorObjetoJanela;

    private void inicializaComboBoxes() {
        
        //inicializando combobox TipoPrevidência
        jcbTipoPrevidencia.addItem(null);
        jcbTipoPrevidencia.addItem(InvestimentoPrevidencia.TIPO_PREVIDENCIA.VGBL);
        jcbTipoPrevidencia.addItem(InvestimentoPrevidencia.TIPO_PREVIDENCIA.PGBL);
        
        //inicializando combobox TipoRentabilidade
        jcbTipoTributacao.addItem(null);
        jcbTipoTributacao.addItem(InvestimentoPrevidencia.TRIBUTACAO_PREVIDENCIA.REGRESSIVA);
        jcbTipoTributacao.addItem(InvestimentoPrevidencia.TRIBUTACAO_PREVIDENCIA.PROGRESSIVA);
        
    }

    // encerra a janela recebida como parâmetro (a qual,
    // deverá ser a janela no qual o frame está contido
    // para, por exemplo, o correto funcionamento do 
    // botão cancelar.
    private void closeJanelaMae() {
        this.janelaMae.dispose();
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnDados = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jtfNome = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jcbTipoPrevidencia = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jcbTipoTributacao = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jtfTaxaCarregamentoAntecipada = new javax.swing.JTextField();
        jtfTaxaCarregamentoPostecipada = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jtfCarencia = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jbNovo = new javax.swing.JButton();
        jbCancelar = new javax.swing.JButton();

        setMinimumSize(new java.awt.Dimension(0, 0));
        setPreferredSize(new java.awt.Dimension(800, 500));

        pnDados.setPreferredSize(new java.awt.Dimension(800, 450));

        jLabel2.setText("Nome");

        jtfNome.setMinimumSize(new java.awt.Dimension(180, 27));

        jLabel3.setText("Tipo");

        jcbTipoPrevidencia.setPreferredSize(new java.awt.Dimension(40, 19));
        jcbTipoPrevidencia.setRequestFocusEnabled(false);

        jLabel4.setText("Tributação");

        jcbTipoTributacao.setPreferredSize(new java.awt.Dimension(40, 19));
        jcbTipoTributacao.setRequestFocusEnabled(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Taxa de carregamento", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("SansSerif", 0, 12))); // NOI18N

        jLabel1.setText("Antecipada");

        jLabel5.setText("Postecipada");

        jtfTaxaCarregamentoAntecipada.setPreferredSize(new java.awt.Dimension(80, 19));

        jtfTaxaCarregamentoPostecipada.setPreferredSize(new java.awt.Dimension(80, 19));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jtfTaxaCarregamentoAntecipada, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jtfTaxaCarregamentoPostecipada, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addGap(6, 6, 6))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel5))
                .addGap(0, 0, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtfTaxaCarregamentoAntecipada, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jtfTaxaCarregamentoPostecipada, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(0, 0, 0))
        );

        jLabel9.setText("Carência (dias)");

        javax.swing.GroupLayout pnDadosLayout = new javax.swing.GroupLayout(pnDados);
        pnDados.setLayout(pnDadosLayout);
        pnDadosLayout.setHorizontalGroup(
            pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnDadosLayout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnDadosLayout.createSequentialGroup()
                        .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(jtfNome, javax.swing.GroupLayout.DEFAULT_SIZE, 374, Short.MAX_VALUE))
                        .addGap(6, 6, 6)
                        .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jcbTipoPrevidencia, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(6, 6, 6)
                        .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4)
                            .addComponent(jcbTipoTributacao, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(6, 6, 6)
                        .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jtfCarencia, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(10, 10, 10))
        );
        pnDadosLayout.setVerticalGroup(
            pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnDadosLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(pnDadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(pnDadosLayout.createSequentialGroup()
                            .addComponent(jLabel3)
                            .addGap(0, 0, 0)
                            .addComponent(jcbTipoPrevidencia, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(pnDadosLayout.createSequentialGroup()
                            .addComponent(jLabel4)
                            .addGap(0, 0, 0)
                            .addComponent(jcbTipoTributacao, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(pnDadosLayout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(0, 0, 0)
                        .addComponent(jtfNome, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pnDadosLayout.createSequentialGroup()
                        .addComponent(jLabel9)
                        .addGap(0, 0, 0)
                        .addComponent(jtfCarencia, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(6, 6, 6)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(335, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel3.setPreferredSize(new java.awt.Dimension(800, 50));

        jbNovo.setText("SALVAR");
        jbNovo.setPreferredSize(new java.awt.Dimension(130, 25));
        jbNovo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbNovoActionPerformed(evt);
            }
        });

        jbCancelar.setText("CANCELAR");
        jbCancelar.setPreferredSize(new java.awt.Dimension(130, 25));
        jbCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jbNovo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jbCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jbNovo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jbCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(10, 10, 10))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(pnDados, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(pnDados, javax.swing.GroupLayout.DEFAULT_SIZE, 444, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jbNovoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbNovoActionPerformed
        if (this.estadoJanela == ESTADO.SALVAR) {
            InvestimentoPrevidencia objeto = getObjetoJanela();
            String erro = ValidaPrevidencia.valida(objeto);

            //caso todos os campos obrigatórios tenham sido preenchidos
            if (erro.isEmpty()) {
                String msg = "";
                if (gerenciadorObjetoJanela.salvaOuAtualiza(objeto)) {
                    msg += "Salvo com sucesso!";                  
//                    exibeCodigo(objeto.getId());
                    this.setEstadoJanela(ESTADO.EDITAR);
                    
                    // encerrando a janelaMãe após o salvamento da entidade em edição.
                    this.closeJanelaMae();
                    
                } else {
                    msg += "Erro no salvamento!";
                }
                
                JOptionPane.showMessageDialog(this, msg);
            } else {
                JOptionPane.showMessageDialog(this, erro);
            }
        } else {
            setEstadoJanela(ESTADO.SALVAR);
        }
    }//GEN-LAST:event_jbNovoActionPerformed

    private void jbCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbCancelarActionPerformed
        // encerrando a janelaMãe após o pressionamento do botão cancelar
        this.closeJanelaMae();
    }//GEN-LAST:event_jbCancelarActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JButton jbCancelar;
    private javax.swing.JButton jbNovo;
    private javax.swing.JComboBox jcbTipoPrevidencia;
    private javax.swing.JComboBox jcbTipoTributacao;
    private javax.swing.JTextField jtfCarencia;
    private javax.swing.JTextField jtfNome;
    private javax.swing.JTextField jtfTaxaCarregamentoAntecipada;
    private javax.swing.JTextField jtfTaxaCarregamentoPostecipada;
    private javax.swing.JPanel pnDados;
    // End of variables declaration//GEN-END:variables
}
