/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.investimentos.view;

import br.com.flaviobarros.simuladordeinvestimentos.investimentos.cdb.view.CdbView;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.controller.GerenciaArmazenamentoInvestimentos;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.fundos.view.FundosView;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.lca.view.LcaView;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.lci.view.LciView;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.AbstractTableModelInvestimentos;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.Investimento;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoCDB;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoFundos;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoLCA;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoLCI;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoPoupanca;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoPrevidencia;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoRDB;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoTesouroIPCA;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.model.InvestimentoTesouroSelic;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.poupanca.view.PoupancaView;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.previdencia.view.PrevidenciaView;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.rdb.view.RdbView;
import br.com.flaviobarros.simuladordeinvestimentos.padroes.Padronizacoes;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.tesouroipca.view.TesouroIPCAView;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.tesouroselic.view.TesouroSelicView;
import java.awt.BorderLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

/**
 *
 * @author flavio
 */
public class InvestimentosView extends javax.swing.JPanel {

    private AbstractTableModelInvestimentos model;
    private JTable tabela;
    private final JFrame janelaMae;
    private JTextArea jtaDescricao;

    /**
     * Creates new form InvestimentosView
     *
     * @param janelaMae
     */
    public InvestimentosView(JFrame janelaMae) {

        initComponents(); // método padrão de inicialização dos JavaSwing (criado automaticamente)
        inicializaComponentes(); // método de inicialização dos componentes da janela (criado manualmente)

        this.janelaMae = janelaMae;
    }

    private void inicializaComponentes() {
        initTabela();
        initJTextArea();
        setDadosTabela(pesquisa());
        setFontes();
    }

    private void setFontes() {
        jbAdicionar.setFont(Padronizacoes.getFontePadrao());
    }

    private void initTabela() {
        this.model = new AbstractTableModelInvestimentos();
        this.tabela = new JTable();
        this.tabela.setModel(model);
        this.jspInvestimentos.setViewportView(this.tabela);
        this.tabela.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        this.ligaListenersExclusaoEdicaoInvestimentos();

        // definindo a larguras maximas/minimas das colunas das colunas 
        this.tabela.getColumnModel().getColumn(0).setMinWidth(100);
        this.tabela.getColumnModel().getColumn(1).setMaxWidth(100);
        this.tabela.getColumnModel().getColumn(2).setMaxWidth(100);
        this.tabela.getColumnModel().getColumn(1).setMinWidth(50);
        this.tabela.getColumnModel().getColumn(2).setMinWidth(50);

        // centralizando conteudo das colunas EDITAR e EXCLUIR
        DefaultTableCellRenderer cellRender = new DefaultTableCellRenderer();
        cellRender.setHorizontalAlignment(SwingConstants.CENTER);
        this.tabela.getColumnModel().getColumn(1).setCellRenderer(cellRender);
        this.tabela.getColumnModel().getColumn(2).setCellRenderer(cellRender);
    }

    private void initJTextArea() {
        this.jtaDescricao = new JTextArea();
        this.jtaDescricao.setEditable(false);
        jspDescricao.setViewportView(this.jtaDescricao);
    }

    private List<Investimento> pesquisa() {

        GerenciaArmazenamentoInvestimentos gerenciaArmazenamentoInvestimentos = new GerenciaArmazenamentoInvestimentos();
        List lista = gerenciaArmazenamentoInvestimentos.getRegistrosDeTodosOsInvestimentos();

        return lista;
    }

    private void setDadosTabela(List<Investimento> objetos) {

        model.setDados(objetos);

//        this.ligaListenersExclusaoEdicaoInvestimentos();
    }

    private void atualizaTabela() {
        setDadosTabela(pesquisa());
    }

//  Realiza a ligação dos listeners para edição e exclusão de investimento ao clicar-se
//  no campo campo "Excluir" ou "Editar" da tabela de exibição dos investimentos.
    private void ligaListenersExclusaoEdicaoInvestimentos() {

        this.tabela.addMouseListener(new MouseListener() {

            @Override
            public void mouseClicked(MouseEvent e) {
                analisaMovimentacaoTabela();
            }

            @Override
            public void mousePressed(MouseEvent e) {
            }

            @Override
            public void mouseReleased(MouseEvent e) {
            }

            @Override
            public void mouseEntered(MouseEvent e) {
            }

            @Override
            public void mouseExited(MouseEvent e) {
            }

        });

        this.tabela.addKeyListener(new KeyListener() {

            @Override
            public void keyReleased(KeyEvent e) {
                int row = tabela.getSelectedRow();
                int colum = tabela.getSelectedColumn();

                Investimento investimentoSelecionado = null;

                // se houver algum campo selecionado.
                if (row > -1 && colum > -1) {
                    investimentoSelecionado = model.getInvestimento(row);
                }

                // caso haja algum investimento selecionado.
                if (investimentoSelecionado != null) {
                    setaDescricao(investimentoSelecionado);
                }
            }

            @Override
            public void keyPressed(KeyEvent e) {
            }

            @Override
            public void keyTyped(KeyEvent e) {
            }

        });
    }

    // * private void analisaMovimentacaoTabela()
    // Verifica se algum campo da tabela esta selecionado, tomando a ação
    // necessária de acordo com o campo selecionado.
    private void analisaMovimentacaoTabela() {
        int row = tabela.getSelectedRow();
        int colum = tabela.getSelectedColumn();
        Investimento investimentoSelecionado = null;

        // se houver algum campo selecionado
        if (row > -1 && colum > -1) {
            investimentoSelecionado = model.getInvestimento(row);
        }

        //se existir um investimento selecionado
        if (investimentoSelecionado != null) {

            if (colum == 1) /*coluna edição selecionada*/ {
                editaInvestimento(investimentoSelecionado);
            } else if (colum == 2) /*coluna exclusão selecionada*/ {
                excluiInvestimento(investimentoSelecionado);
            }

            if (colum == 0 || colum == 1) /*caso haja uma coluna selecionada e ela não seja a da opção excluir*/ {
                setaDescricao(investimentoSelecionado);
            } else if (colum == 2) /*caso a coluna selecionada seja a referente a opção excluir*/ {
                if (tabela.getSelectedRow() != row) {
                    setaDescricao(null);
                }
            }
        }
    }

    private void editaInvestimento(Investimento entidade) {
        JDialog janelaEdicaoInvestimento = new JDialog(janelaMae);

        if (null != entidade.getTipo()) {
            switch (entidade.getTipo()) {

                // Abrindo janela para edição de LCI
                case LCI:
                    LciView lciView = new LciView(janelaEdicaoInvestimento, (InvestimentoLCI) entidade);
                    lciView.setEstadoJanela(LciView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, lciView, "Investmento LCI: Alteração");
                    break;

                // Abrindo janela para edição de LCA
                case LCA:
                    LcaView lcaView = new LcaView(janelaEdicaoInvestimento, (InvestimentoLCA) entidade);
                    lcaView.setEstadoJanela(LcaView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, lcaView, "Investmento LCA: Alteração");
                    break;

                // Abrindo janela para edição de CDB
                case CDB:
                    CdbView cdbView = new CdbView(janelaEdicaoInvestimento, (InvestimentoCDB) entidade);
                    cdbView.setEstadoJanela(CdbView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, cdbView, "Investmento CDB: Alteração");
                    break;

                // Abrindo janela para edição de RDB
                case RDB:
                    RdbView rdbView = new RdbView(janelaEdicaoInvestimento, (InvestimentoRDB) entidade);
                    rdbView.setEstadoJanela(RdbView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, rdbView, "Investmento RDB: Alteração");
                    break;

                // Abrindo janela para edição de Poupanca
                case POUPANCA:
                    PoupancaView poupancaView = new PoupancaView(janelaEdicaoInvestimento, (InvestimentoPoupanca) entidade);
                    poupancaView.setEstadoJanela(PoupancaView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, poupancaView, "Investmento Poupanca: Alteração");
                    break;

                // Abrindo janela para edição de Fundos de Investimento
                case FUNDO_DE_INVESTIMENTO:
                    FundosView fundosView = new FundosView(janelaEdicaoInvestimento, (InvestimentoFundos) entidade);
                    fundosView.setEstadoJanela(FundosView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, fundosView, "Fundos de Investimentos: Alteração");
                    break;

                // Abrindo janela para edição de Previdência   
                case PREVIDENCIA:
                    PrevidenciaView previdenciaView = new PrevidenciaView(janelaEdicaoInvestimento, (InvestimentoPrevidencia) entidade);
                    previdenciaView.setEstadoJanela(PrevidenciaView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, previdenciaView, "Investimento Previdência: Alteração");
                    break;

                // Abrindo janela para edição de Tesouro Selic
                case TESOURO_SELIC:
                    TesouroSelicView tesouroSelicView = new TesouroSelicView(janelaEdicaoInvestimento, (InvestimentoTesouroSelic) entidade);
                    tesouroSelicView.setEstadoJanela(TesouroSelicView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, tesouroSelicView, "Investimento Tesouro Selic: Alteração");
                    break;

                // Abrindo janela para edição de Tesouro IPCA
                case TESOURO_IPCA:
                    TesouroIPCAView tesouroIPCAView = new TesouroIPCAView(janelaEdicaoInvestimento, (InvestimentoTesouroIPCA) entidade);
                    tesouroIPCAView.setEstadoJanela(TesouroIPCAView.ESTADO.SALVAR);
                    openJanelaCadastroInvestimento(janelaEdicaoInvestimento, tesouroIPCAView, "Investimento Tesouro IPCA: Alteração");
                    break;

                default:
                    break;
            }
        }

        atualizaTabela();
    }

    private void excluiInvestimento(Investimento entidade) {
        if (JOptionPane.showConfirmDialog(janelaMae, "Deseja realmente excluir o investimento selecionado?", "Confirmação", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
            GerenciaArmazenamentoInvestimentos gerenciaArmazenamentoInvestimentos = new GerenciaArmazenamentoInvestimentos();
            gerenciaArmazenamentoInvestimentos.remove(entidade);

            atualizaTabela();
        }
    }

    private void setaDescricao(Investimento entidade) {
        if (entidade != null) {
            this.jtaDescricao.setText(entidade.getDescricao());
        } else {
            this.jtaDescricao.setText("");
        }

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jspInvestimentos = new javax.swing.JScrollPane();
        jbAdicionar = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jspDescricao = new javax.swing.JScrollPane();

        setPreferredSize(new java.awt.Dimension(536, 300));

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder("INVESTIMENTOS"), "INVESTIMENTOS")));
        jPanel1.setPreferredSize(new java.awt.Dimension(300, 300));

        jspInvestimentos.setPreferredSize(new java.awt.Dimension(300, 200));

        jbAdicionar.setText("Adicionar");
        jbAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbAdicionarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jspInvestimentos, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(jbAdicionar)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(jspInvestimentos, javax.swing.GroupLayout.DEFAULT_SIZE, 214, Short.MAX_VALUE)
                .addGap(5, 5, 5)
                .addComponent(jbAdicionar))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("DESCRIÇÃO"));
        jPanel2.setPreferredSize(new java.awt.Dimension(200, 200));

        jspDescricao.setPreferredSize(new java.awt.Dimension(200, 180));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(jspDescricao, javax.swing.GroupLayout.DEFAULT_SIZE, 193, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jspDescricao, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 303, Short.MAX_VALUE)
                .addGap(10, 10, 10)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 203, Short.MAX_VALUE)
                .addGap(10, 10, 10))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 276, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 276, Short.MAX_VALUE))
                .addGap(12, 12, 12))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jbAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbAdicionarActionPerformed

        // Abrindo a janela para a obtenção do tipo de investimento a ser inserido.
        List<Investimento.TIPO> aux = new ArrayList<>();
        EscolhaTipoInvestimentoView dialogEscolhaTipoInvestimentoView = new EscolhaTipoInvestimentoView(janelaMae, true, aux);
        dialogEscolhaTipoInvestimentoView.setLocationRelativeTo(janelaMae);
        dialogEscolhaTipoInvestimentoView.setVisible(true);

        // Janela que exibirá o cadastro de investimentos.
        JDialog dialogNovoInvestimento = new JDialog(janelaMae);

        // Abrindo a janela para o cadastro do investimento escolhido.
        if (aux.size() > 0) {
            if (null != aux.get(0)) {
                switch (aux.get(0)) {

                    // Abrindo janela de cadastro de LCI
                    case LCI:
                        LciView painelInvestimentoLCI = new LciView(dialogNovoInvestimento);
                        painelInvestimentoLCI.setEstadoJanela(LciView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoLCI, "Cadastro de Investimento: LCI");
                        break;

                    // Abrindo janela de cadastro de LCA    
                    case LCA:
                        LcaView painelInvestimentoLCA = new LcaView(dialogNovoInvestimento);
                        painelInvestimentoLCA.setEstadoJanela(LcaView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoLCA, "Cadastro de Investimento: LCA");
                        break;

                    // Abrindo janela de cadastro de CDB
                    case CDB:

                        CdbView painelInvestimentoCDB = new CdbView(dialogNovoInvestimento);
                        painelInvestimentoCDB.setEstadoJanela(CdbView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoCDB, "Cadastro de Investimento: CDB");
                        break;

                    // Abrindo janela de cadastro de RDB
                    case RDB:
                        RdbView painelInvestimentoRDB = new RdbView(dialogNovoInvestimento);
                        painelInvestimentoRDB.setEstadoJanela(RdbView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoRDB, "Cadastro de Investimento: RDB");
                        break;

                    // Abrindo janela de cadastro de Poupança
                    case POUPANCA:
                        PoupancaView painelInvestimentoPoupanca = new PoupancaView(dialogNovoInvestimento);
                        painelInvestimentoPoupanca.setEstadoJanela(PoupancaView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoPoupanca, "Cadastro de Investimento: Poupança");
                        break;

                    // Abrindo janela de cadastro de Fundos de Investimento
                    case FUNDO_DE_INVESTIMENTO:
                        FundosView painelInvestimentoFundos = new FundosView(dialogNovoInvestimento);
                        painelInvestimentoFundos.setEstadoJanela(FundosView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoFundos, "Cadastro de Investimento: Fundo de Investimento");
                        break;

                    // Abrindo janela de cadastro de Previdência    
                    case PREVIDENCIA:
                        PrevidenciaView painelInvestimentoPrevidencia = new PrevidenciaView(dialogNovoInvestimento);
                        painelInvestimentoPrevidencia.setEstadoJanela(PrevidenciaView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoPrevidencia, "Cadastro de Investimento: Previdência");
                        break;

                    // Abrindo janela de cadastro de Tesouro Selic
                    case TESOURO_SELIC:
                        TesouroSelicView painelInvestimentoTesouroSelic = new TesouroSelicView(dialogNovoInvestimento);
                        painelInvestimentoTesouroSelic.setEstadoJanela(TesouroSelicView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoTesouroSelic, "Cadastro de Investimento: Tesouro Selic");
                        break;

                    // Abrindo janela de cadastro de Tesouro IPCA
                    case TESOURO_IPCA:
                        TesouroIPCAView painelInvestimentoTesouroIPCA = new TesouroIPCAView(dialogNovoInvestimento);
                        painelInvestimentoTesouroIPCA.setEstadoJanela(TesouroIPCAView.ESTADO.SALVAR);
                        openJanelaCadastroInvestimento(dialogNovoInvestimento, painelInvestimentoTesouroIPCA, "Cadastro de Investimento: Tesouro IPCA");
                        break;

                    default:
                        break;
                }
            }
        }

//      atualizando os dados dos investimentos para caso tenha havido algum investimento inserido
        this.atualizaTabela();

    }//GEN-LAST:event_jbAdicionarActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton jbAdicionar;
    private javax.swing.JScrollPane jspDescricao;
    private javax.swing.JScrollPane jspInvestimentos;
    // End of variables declaration//GEN-END:variables

//    ## possível melhoria: tornar a classe genérica para a exibição de qualquer painel dado qualquer
//    ## JDialog, qualquer JPanel e qualquer título.
//    Sete o estado da janela de cadastro desejada antes de utilizar esta função
//    Ex: painelInvestimento.setEstadoJanela(CdbView.ESTADO.SALVAR);
//    * JDialog janelaDeExibicao: JDialog já instanciada para a exibição do JPanel painelCadastro (também recebido como parâmetro);
//    * JPanel painelCadastro: painel a ser exibido;
//    * String titulo: título da JDialog a ser execultada.
    private void openJanelaCadastroInvestimento(JDialog janelaDeExibicao, JPanel painelCadastro, String titulo) {

        janelaDeExibicao.setTitle(titulo);
        janelaDeExibicao.setModal(true);
        janelaDeExibicao.setSize(janelaMae.getSize());
        janelaDeExibicao.setLocationRelativeTo(janelaMae);
        janelaDeExibicao.getContentPane().removeAll();
        janelaDeExibicao.getContentPane().add(painelCadastro, BorderLayout.CENTER);

        janelaDeExibicao.setVisible(true);
        janelaDeExibicao.dispose();
    }

}
