/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.relatorio.controller;

import br.com.flaviobarros.simuladordeinvestimentos.relatorio.model.ModeloItemGrafico;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.Objects;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.data.category.DefaultCategoryDataset;

/**
 *
 * @author flavio
 */
public class GeradorDeGrafico {

    public static BufferedImage gerarGraficoRentabilidade(String tituloGrafico, ArrayList arrayValores, GerenciaRelatorio.ESCALA_CASAS_DECIMAIS_GRAFICO escala)
            throws Exception {

        Double minValue = Double.MAX_VALUE;
        Double maxValue = Double.MIN_VALUE;
        
        BufferedImage buf = null;
        String tituloEixoX = "Meses";
        String tituloEixoY = "Valores (em R$)";

        try {
            DefaultCategoryDataset defaultCategoryDataset = new DefaultCategoryDataset();

            // System.out.println("\n em gerarGraficoRentabilidade");
            
            for (int i = 0; i < arrayValores.size(); i++) {
                ModeloItemGrafico modelo = (ModeloItemGrafico) arrayValores.get(i);
                
                Double valor = modelo.getMontante();

                if(valor != null) {
                    if (escala == GerenciaRelatorio.ESCALA_CASAS_DECIMAIS_GRAFICO.EM_MILHOES) {
                        valor = valor/1000000.00;
                        tituloEixoY = "Valores (em milhões R$)";
                    }

                    if (escala == GerenciaRelatorio.ESCALA_CASAS_DECIMAIS_GRAFICO.EM_BILHOES) {
                        valor = valor/1000000000.00;
                        tituloEixoY = "Valores (em bilhões R$)";
                    }

                    if (escala == GerenciaRelatorio.ESCALA_CASAS_DECIMAIS_GRAFICO.EM_TRILHOES) {
                        valor = valor/1000000000000.00;
                        tituloEixoY = "Valores (em trilhões R$)";
                    }

                    if (escala == GerenciaRelatorio.ESCALA_CASAS_DECIMAIS_GRAFICO.EM_QUADRILHOES) {
                        valor = valor/1000000000000000.00;
                        tituloEixoY = "Valores (em quadrilhões R$)";
                    }
                    
                        if (valor > maxValue) {
                            maxValue = valor;
                        }
                        
                        if (valor < minValue) {
                            minValue = valor;
                        }
                    
                    // DefaultCategoryDataset.addValue(valor, o nome dessa linha (porque um gráfico pode ter várias), posição desse valor no eixo X.)
                    defaultCategoryDataset.addValue(valor, modelo.getInvestimento(), modelo.getMes());
                }
                
            }

            JFreeChart chart = ChartFactory.createLineChart(tituloGrafico,
                    tituloEixoX,
                    tituloEixoY,
                    defaultCategoryDataset,
                    PlotOrientation.VERTICAL,
                    true,
                    false,
                    false);

            
            
            chart.setBorderVisible(true);
            chart.setBorderPaint(Color.black);

            final CategoryPlot plot = chart.getCategoryPlot();
            plot.setBackgroundPaint(Color.white);
            
            if (Objects.equals(minValue, maxValue)) {  // caso não exista itervalo
                // definindo um intervalo
                minValue -= 10;
                maxValue += 10;
            } else if (minValue > 0) { // ajustando valor do minValue
                Double valorAjustado = minValue - (maxValue - minValue) / 10;
                
                if (valorAjustado > 0) {
                    minValue = valorAjustado;
                }
            }
           
            if (minValue < maxValue) {
                // Seta o range do eixo Y de minValue a maxValue
                plot.getRangeAxis().setRange(minValue, maxValue);
            }
                        
            LineAndShapeRenderer renderer = (LineAndShapeRenderer)plot.getRenderer();
            renderer.setBaseStroke(new BasicStroke(3)); //aumenta a largura das series          
            
//            buf = chart.createBufferedImage(1400, 700);// 56 intervalos página horizontal - 48 ideal
            buf = chart.createBufferedImage(1000, 500);// 40 intervalos página vertical - 36 ideal

        } catch (Exception e) {
            throw new Exception(e);
        }

        return buf;
    }

}
