/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.relatorio.model;

import br.com.flaviobarros.simuladordeinvestimentos.simulacao.model.DadosSimulacao;
import java.text.NumberFormat;
import java.util.Calendar;

/**
 *
 * @author flavio
 */
public class ParametroInformacoesDoRelatorio {
    private String valorInvestido;
    private String duracaoInvestimento;
    private String intervaloDoRelatorio;
    private String mesAnoAplicacao;
    
    public ParametroInformacoesDoRelatorio(Double valorInvestido, Integer duracaoInvestimento, Integer intervaloDoRelatorio, Calendar mesAnoAplicacao) {
        this.valorInvestido = formataNumero(valorInvestido);
        this.duracaoInvestimento = duracaoInvestimento.toString();
        this.intervaloDoRelatorio = "";
        
        if (intervaloDoRelatorio == 1){
            this.intervaloDoRelatorio = "MENSAL";
        } else if (intervaloDoRelatorio == 2){
            this.intervaloDoRelatorio = "BIMESTRAL";
        } else if (intervaloDoRelatorio == 3){
            this.intervaloDoRelatorio = "TRIMESTRAL";
        } else if (intervaloDoRelatorio == 6){
            this.intervaloDoRelatorio = "SEMESTRAL";
        } else if (intervaloDoRelatorio == 12){
            this.intervaloDoRelatorio = "ANUAL";
        }
            
        this.mesAnoAplicacao = mesAnoAplicacao.toString();
    }

    public ParametroInformacoesDoRelatorio(DadosSimulacao dadosSimulacao) {
        this.valorInvestido = formataNumero(dadosSimulacao.getValorInvestimento());
        this.duracaoInvestimento = dadosSimulacao.getDuracaoInvestimento().toString();
        this.intervaloDoRelatorio = dadosSimulacao.getIntervaloRelatorio().toString();
        this.mesAnoAplicacao = dadosSimulacao.getMesAnoAplicacao().toString();
    }
    
    private String formataNumero(Double valor) {
        
        String str = NumberFormat.getCurrencyInstance().format(valor);
        
        str = str.replaceAll("[^0|1|2|3|4|5|6|7|8|9|.|,|-]", "");
        
        return str;
    }
    
    //-- GETTERS AND SETTERS -------------------------------------------------------

    public String getValorInvestido() {
        return valorInvestido;
    }

    public void setValorInvestido(String valorInvestido) {
        this.valorInvestido = valorInvestido;
    }

    public String getDuracaoInvestimento() {
        return duracaoInvestimento;
    }

    public void setDuracaoInvestimento(String duracaoInvestimento) {
        this.duracaoInvestimento = duracaoInvestimento;
    }

    public String getIntervaloDoRelatorio() {
        return intervaloDoRelatorio;
    }

    public void setIntervaloDoRelatorio(String intervaloDoRelatorio) {
        this.intervaloDoRelatorio = intervaloDoRelatorio;
    }

    public String getMesAnoAplicacao() {
        return mesAnoAplicacao;
    }

    public void setMesAnoAplicacao(String mesAnoAplicacao) {
        this.mesAnoAplicacao = mesAnoAplicacao;
    }
    
    
}
