/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.relatorio.model;

import java.text.NumberFormat;

/**
 *
 * @author flavio
 */
public class ParametroRelatorioTabelaRentabilidade {
    
    private String colunaNome;
    private String colunaCenario;
    private String colunaRentabilidadeCenarioA;
    private String colunaRentabilidadeCenarioB;
    private String colunaRentabilidadeCenarioC;
    private String colunaRentabilidadeCenarioD;
    private String colunaRentabilidadeCenarioE;
    private String colunaRentabilidadeCenarioF;

    public ParametroRelatorioTabelaRentabilidade(){
    }
    
    public ParametroRelatorioTabelaRentabilidade(String nomeInvestimento, 
                                                    String nomeCenario,
                                                    Double rentabilidadeCenarioA,
                                                    Double rentabilidadeCenarioB,
                                                    Double rentabilidadeCenarioC,
                                                    Double rentabilidadeCenarioD,
                                                    Double rentabilidadeCenarioE,
                                                    Double rentabilidadeCenarioF) {
        
        this.colunaNome = nomeInvestimento;
        this.colunaCenario = nomeCenario;
        
        inicializaColunasRentabilidade();
        
        if(rentabilidadeCenarioA != null)
            this.colunaRentabilidadeCenarioA = this.formataNumero(rentabilidadeCenarioA);
        
        if(rentabilidadeCenarioB != null)
            this.colunaRentabilidadeCenarioB = this.formataNumero(rentabilidadeCenarioB);
        
        if(rentabilidadeCenarioC != null)
            this.colunaRentabilidadeCenarioC = this.formataNumero(rentabilidadeCenarioC);
        
        if(rentabilidadeCenarioD != null)
            this.colunaRentabilidadeCenarioD = this.formataNumero(rentabilidadeCenarioD);
        
        if(rentabilidadeCenarioE != null)
            this.colunaRentabilidadeCenarioE = this.formataNumero(rentabilidadeCenarioE);
        
        if(rentabilidadeCenarioF != null)
            this.colunaRentabilidadeCenarioF = this.formataNumero(rentabilidadeCenarioF);
    }
    
    public void header(String mesA, String mesB, String mesC, String mesD, String mesE, String mesF) {
        
        String pre = "::  ";
        String complemento = "Mês ";
        String pos = "  ::";
        
        inicializaColunasRentabilidade();
        
        this.colunaNome = pre + "INVESTIMENTO" + pos;
        this.colunaCenario = "CENÁRIO";
        
        if(!mesA.isEmpty())
            this.colunaRentabilidadeCenarioA = pre + complemento + mesA + pos;
        
        if(!mesB.isEmpty())
            this.colunaRentabilidadeCenarioB = pre + complemento  + mesB + pos;
        
        if(!mesC.isEmpty())
            this.colunaRentabilidadeCenarioC = pre + complemento  + mesC + pos;
        
        if(!mesD.isEmpty())
            this.colunaRentabilidadeCenarioD = pre + complemento  + mesD + pos;
        
        if(!mesE.isEmpty())
            this.colunaRentabilidadeCenarioE = pre + complemento  + mesE + pos;
        
        if(!mesF.isEmpty())
            this.colunaRentabilidadeCenarioF = pre + complemento  + mesF + pos;
    }
    
    public void quebraDelinha() {
        this.colunaNome = "";
        this.colunaCenario = "";
        inicializaColunasRentabilidade();
    }
  
    private String formataNumero(Double valor) {
        
        String str = NumberFormat.getCurrencyInstance().format(valor);
        
        str = str.replaceAll("[^0|1|2|3|4|5|6|7|8|9|.|,|-]", "");
        
        return str;
    }
    
    private void inicializaColunasRentabilidade() {
        this.colunaRentabilidadeCenarioA = "";
        this.colunaRentabilidadeCenarioB = "";
        this.colunaRentabilidadeCenarioC = "";
        this.colunaRentabilidadeCenarioD = "";
        this.colunaRentabilidadeCenarioE = "";
        this.colunaRentabilidadeCenarioF = "";
    }
    
        
//  --- SETTERS ----------------------------------------------------------------

    public void setColunaNome(String colunaNome) {
        this.colunaNome = colunaNome;
    }

    public void setColunaCenario(String colunaCenario) {
        this.colunaCenario = colunaCenario;
    }
    
    public void setColunaRentabilidadeCenarioA(String colunaRentabilidadeCenarioA) {
        this.colunaRentabilidadeCenarioA = colunaRentabilidadeCenarioA;
    }

    public void setColunaRentabilidadeCenarioB(String colunaRentabilidadeCenarioB) {
        this.colunaRentabilidadeCenarioB = colunaRentabilidadeCenarioB;
    }

    public void setColunaRentabilidadeCenarioC(String colunaRentabilidadeCenarioC) {
        this.colunaRentabilidadeCenarioC = colunaRentabilidadeCenarioC;
    }

    public void setColunaRentabilidadeCenarioD(String colunaRentabilidadeCenarioD) {
        this.colunaRentabilidadeCenarioD = colunaRentabilidadeCenarioD;
    }

    public void setColunaRentabilidadeCenarioE(String colunaRentabilidadeCenarioE) {
        this.colunaRentabilidadeCenarioE = colunaRentabilidadeCenarioE;
    }

    public void setColunaRentabilidadeCenarioF(String columnRentabilidadeCenarioF) {
        this.colunaRentabilidadeCenarioF = columnRentabilidadeCenarioF;
    }
    
    
//  --- GETTERS ----------------------------------------------------------------
    public String getColunaNome() {
        return colunaNome;
    }

    public String getColunaCenario() {
        return colunaCenario;
    }
    
    public String getColunaRentabilidadeCenarioA() {
        return colunaRentabilidadeCenarioA;
    }

    public String getColunaRentabilidadeCenarioB() {
        return colunaRentabilidadeCenarioB;
    }

    public String getColunaRentabilidadeCenarioC() {
        return colunaRentabilidadeCenarioC;
    }

    public String getColunaRentabilidadeCenarioD() {
        return colunaRentabilidadeCenarioD;
    }

    public String getColunaRentabilidadeCenarioE() {
        return colunaRentabilidadeCenarioE;
    }

    public String getColunaRentabilidadeCenarioF() {
        return colunaRentabilidadeCenarioF;
    }

    
}
