/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.simulacao.controller;

import br.com.flaviobarros.simuladordeinvestimentos.cenarios.controller.GerenciadorAuxiliarCenariosDeSimulacao;
import br.com.flaviobarros.simuladordeinvestimentos.simulacao.model.DadosSimulacao;

/**
 *
 * @author flavio
 */
public class ValidaSimulacao {

    public static String valida(DadosSimulacao entidade) {
        String erro = "";

        if (entidade.getValorInvestimento() == null) {
            erro += "Informe o valor do investimento.\n";
        }

        if (entidade.getDuracaoInvestimento() == null) {
            erro += "Informe a duração do investimento (em meses).\n";
        }

        if (entidade.getIntervaloRelatorio() == null) {
            erro += "Selecione o intervalo a ser utilizado no relatório.\n";
        }
        
        if (entidade.getIntervaloRelatorio() != null && entidade.getDuracaoInvestimento() != null) {
            if (entidade.getIntervaloRelatorioEmMeses() > entidade.getDuracaoInvestimento()) {
                erro += "O prazo do investimento deve ser superior a quantidade de meses do intervalo escolhido.\n";
            }
        }

        if (entidade.getMesAnoAplicacao() == null) {
            erro += "Selecione o mês/ano da aplicação.\n";
        }
        
        if (!(entidade.isSimularCenario1() || entidade.isSimularCenario2() || entidade.isSimularCenario3() || entidade.isSimularCenario4() || entidade.isSimularCenario5() || entidade.isSimularCenario6())) {
                erro += "Selecione pelo menos um dos cenários para a simulação.\n";
        }

        // impedindo que esta consulta seja executada desnecessáriamente multiplas vezes.
        if (erro.isEmpty()) {
            GerenciadorAuxiliarCenariosDeSimulacao gerenciadorAuxiliarCenariosDeSimulacao = new GerenciadorAuxiliarCenariosDeSimulacao();

            if (!(gerenciadorAuxiliarCenariosDeSimulacao.cenariosEstaoDefinidos(entidade.isSimularCenario1(), entidade.isSimularCenario2(), entidade.isSimularCenario3(), entidade.isSimularCenario4(), entidade.isSimularCenario5(), entidade.isSimularCenario6()))) {
                erro += "Defina previamente na janela CENÁRIOS todos os valores para os cenários aos quais deseja  realizar a simulação simulação!\n";
            }
        }

        return erro;
    }
}
