/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.simulacao.model;

import java.util.Calendar;

/**
 * Contem os dados a serem utilizados na simulação do investimento
 * 
 * @author flavio
 */
public class DadosSimulacao {
    
    public enum INTERVALO{/*--------------------------------------------------analizar se esta enumeração com os tipos de investimentos está sendo util (utilizada)*/
        MENSAL("Mensal"),
        BIMESTRAL("Bimestral"),
        TRIMESTRAL("Trimestral"),
        SEMESTRAL("Semestral"),
        ANUAL("Anual");
        
        private final String descricao;

        private INTERVALO(String descricao) {
            this.descricao = descricao;
        }

        public String getDescricao() {
            return descricao;
        }
    }
    
    private Double valorInvestimento;
    private Integer duracaoInvestimento;
    private DadosSimulacao.INTERVALO intervaloRelatorio;
    private Calendar mesAnoAplicacao;
    
    private boolean simularCenario1;
    private boolean simularCenario2;
    private boolean simularCenario3;
    private boolean simularCenario4;
    private boolean simularCenario5;
    private boolean simularCenario6;

    public DadosSimulacao(Double valorInvestimento, Integer duracaoInvestimento, INTERVALO intervaloRelatorio, Calendar mesAnoAplicacao, boolean cenario1, boolean cenario2, boolean cenario3, boolean cenario4, boolean cenario5, boolean cenario6) {
        this.valorInvestimento = valorInvestimento;
        this.duracaoInvestimento = duracaoInvestimento;
        this.intervaloRelatorio = intervaloRelatorio;
        this.mesAnoAplicacao = mesAnoAplicacao;
        this.simularCenario1 = cenario1;
        this.simularCenario2 = cenario2;
        this.simularCenario3 = cenario3;
        this.simularCenario4 = cenario4;
        this.simularCenario5 = cenario5;
        this.simularCenario6 = cenario6;
    }

    public DadosSimulacao() {
        this.simularCenario1 = false;
        this.simularCenario2 = false;
        this.simularCenario3 = false;
        this.simularCenario4 = false;
        this.simularCenario5 = false;
        this.simularCenario6 = false;
    }
    
    public int getIntervaloRelatorioEmMeses()  {
        if (null != this.intervaloRelatorio) switch (this.intervaloRelatorio) {
            case MENSAL:
                return 1;
            case BIMESTRAL:
                return 2;
            case TRIMESTRAL:
                return 3;
            case SEMESTRAL:
                return 6;
            case ANUAL:
                return 12;
            default:
                break;
        }
        
        return 0;
    }

    
    //-- GETTERS AND SETTERS -------------------------------------------------------
    public Double getValorInvestimento()        
    {
        return this.valorInvestimento;
    }

    public void setValorInvestimento(Double valorInvestimento) {
        this.valorInvestimento = valorInvestimento;
    }

    public Integer getDuracaoInvestimento() {
        return duracaoInvestimento;
    }

    public void setDuracaoInvestimento(Integer duracaoInvestimento) {
        this.duracaoInvestimento = duracaoInvestimento;
    }

    public DadosSimulacao.INTERVALO getIntervaloRelatorio() {
        return intervaloRelatorio;
    }

    public void setIntervaloRelatorio(DadosSimulacao.INTERVALO intervaloRelatorio) {
        this.intervaloRelatorio = intervaloRelatorio;
    }

    public Calendar getMesAnoAplicacao() {
        return mesAnoAplicacao;
    }

    public void setMesAnoAplicacao(Calendar mesAnoAplicacao) {
        this.mesAnoAplicacao = mesAnoAplicacao;
    }

    public boolean isSimularCenario1() {
        return simularCenario1;
    }

    public void setSimularCenario1(boolean simularCenario1) {
        this.simularCenario1 = simularCenario1;
    }

    public boolean isSimularCenario2() {
        return simularCenario2;
    }

    public void setSimularCenario2(boolean simularCenario2) {
        this.simularCenario2 = simularCenario2;
    }

    public boolean isSimularCenario3() {
        return simularCenario3;
    }

    public void setSimularCenario3(boolean simularCenario3) {
        this.simularCenario3 = simularCenario3;
    }

    public boolean isSimularCenario4() {
        return simularCenario4;
    }

    public void setSimularCenario4(boolean simularCenario4) {
        this.simularCenario4 = simularCenario4;
    }

    public boolean isSimularCenario5() {
        return simularCenario5;
    }

    public void setSimularCenario5(boolean simularCenario5) {
        this.simularCenario5 = simularCenario5;
    }

    public boolean isSimularCenario6() {
        return simularCenario6;
    }

    public void setSimularCenario6(boolean simularCenario6) {
        this.simularCenario6 = simularCenario6;
    }

}
