/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.simuladordeinvestimentos.telaprincipal;

import br.com.flaviobarros.simuladordeinvestimentos.cenarios.view.CenariosView;
import br.com.flaviobarros.simuladordeinvestimentos.investimentos.view.InvestimentosView;
import br.com.flaviobarros.simuladordeinvestimentos.padroes.Padronizacoes;
import br.com.flaviobarros.simuladordeinvestimentos.resources.ControleRecursos;
import br.com.flaviobarros.simuladordeinvestimentos.simulacao.view.SimulacaoView;
import java.awt.BorderLayout;
import java.io.InputStream;
import javax.swing.JPanel;
import javax.swing.UIManager;

/**
 *
 * @author flavio
 */
public class TelaPrincipal extends javax.swing.JFrame {

    private InvestimentosView investimentosView;
    private CenariosView cenariosView;
    private SimulacaoView simulacaoView;
    
    
    /**
     * Creates new form TelaPrincipal
     */
    public TelaPrincipal() {
        initComponents();
        inicializacoesComponentes();        
    }
    
    /**
     * Método para configurar o estilo das fontes dos elementos da janela.
     */
    private void setFontes() {
        jbInvestimentos.setFont(Padronizacoes.getFontePadrao());
        jbCenarios.setFont(Padronizacoes.getFontePadrao());
        jbSimulacao.setFont(Padronizacoes.getFontePadrao());
        
        UIManager.put("OptionPane.messageFont", Padronizacoes.getFontePadrao());
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jpConteudo = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jpBotoes = new javax.swing.JPanel();
        jbInvestimentos = new javax.swing.JButton();
        jbCenarios = new javax.swing.JButton();
        jbSimulacao = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Simulador de Investimentos");
        setPreferredSize(new java.awt.Dimension(810, 470));

        jLabel1.setFont(new java.awt.Font("SansSerif", 3, 14)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Bem vindo ao Simulador de Investimentos!");

        jLabel2.setFont(new java.awt.Font("SansSerif", 2, 12)); // NOI18N
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel2.setText("1° cadastre o(s) investimento(s) (botão INVESTIMENTOS)");

        jLabel3.setFont(new java.awt.Font("SansSerif", 2, 12)); // NOI18N
        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel3.setText("2º defina o(s) cenário(s) (botão CENÁRIOS)");

        jLabel4.setFont(new java.awt.Font("SansSerif", 2, 12)); // NOI18N
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel4.setText("3º realize a simulação (botão SIMULAÇÃO)");

        jLabel5.setFont(new java.awt.Font("Dialog", 2, 12)); // NOI18N
        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel5.setText("(foco em renda fixa)");

        jLabel6.setFont(new java.awt.Font("Dialog", 2, 12)); // NOI18N
        jLabel6.setText("Instruções:");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(jLabel1)
                .addGap(0, 0, 0)
                .addComponent(jLabel5)
                .addGap(15, 15, 15)
                .addComponent(jLabel6)
                .addGap(6, 6, 6)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel4)
                .addGap(6, 6, 6))
        );

        jLabel1.getAccessibleContext().setAccessibleName("");
        jLabel2.getAccessibleContext().setAccessibleName("");
        jLabel3.getAccessibleContext().setAccessibleName("");
        jLabel4.getAccessibleContext().setAccessibleName("");

        javax.swing.GroupLayout jpConteudoLayout = new javax.swing.GroupLayout(jpConteudo);
        jpConteudo.setLayout(jpConteudoLayout);
        jpConteudoLayout.setHorizontalGroup(
            jpConteudoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpConteudoLayout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jpConteudoLayout.setVerticalGroup(
            jpConteudoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpConteudoLayout.createSequentialGroup()
                .addGap(100, 100, 100)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jpBotoes.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jpBotoes.setMinimumSize(new java.awt.Dimension(100, 60));
        jpBotoes.setOpaque(false);
        jpBotoes.setPreferredSize(new java.awt.Dimension(600, 60));

        jbInvestimentos.setText("INVESTIMENTOS");
        jbInvestimentos.setPreferredSize(new java.awt.Dimension(150, 30));
        jbInvestimentos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbInvestimentosActionPerformed(evt);
            }
        });

        jbCenarios.setText("CENÁRIOS");
        jbCenarios.setPreferredSize(new java.awt.Dimension(150, 30));
        jbCenarios.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbCenariosActionPerformed(evt);
            }
        });

        jbSimulacao.setText("SIMULAÇÃO");
        jbSimulacao.setPreferredSize(new java.awt.Dimension(150, 30));
        jbSimulacao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbSimulacaoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jpBotoesLayout = new javax.swing.GroupLayout(jpBotoes);
        jpBotoes.setLayout(jpBotoesLayout);
        jpBotoesLayout.setHorizontalGroup(
            jpBotoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpBotoesLayout.createSequentialGroup()
                .addContainerGap(66, Short.MAX_VALUE)
                .addComponent(jbInvestimentos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(20, 20, 20)
                .addComponent(jbCenarios, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(20, 20, 20)
                .addComponent(jbSimulacao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(45, Short.MAX_VALUE))
        );
        jpBotoesLayout.setVerticalGroup(
            jpBotoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpBotoesLayout.createSequentialGroup()
                .addGap(15, 15, 15)
                .addGroup(jpBotoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jbInvestimentos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jbCenarios, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jbSimulacao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(15, 15, 15))
        );

        jbInvestimentos.getAccessibleContext().setAccessibleName("jButton1");
        jbInvestimentos.getAccessibleContext().setAccessibleDescription("");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jpConteudo, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jpBotoes, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 605, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jpConteudo, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jpBotoes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jpConteudo.getAccessibleContext().setAccessibleName("PainelDeConteudo");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jbCenariosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbCenariosActionPerformed
        desalocaCenarioViewAnterior();
        
        cenariosView = new CenariosView(this);
        setPainelPrincipal(cenariosView);
    }//GEN-LAST:event_jbCenariosActionPerformed

    private void jbInvestimentosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbInvestimentosActionPerformed
        desalocaInvestimentosViewAnterior();
        
        investimentosView = new InvestimentosView(this);
        setPainelPrincipal(investimentosView);
    }//GEN-LAST:event_jbInvestimentosActionPerformed

    private void jbSimulacaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbSimulacaoActionPerformed
        desalocaSimulacaoViewAnterior();
        
        simulacaoView = new SimulacaoView(this);
        setPainelPrincipal(simulacaoView);
    }//GEN-LAST:event_jbSimulacaoActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton jbCenarios;
    private javax.swing.JButton jbInvestimentos;
    private javax.swing.JButton jbSimulacao;
    private javax.swing.JPanel jpBotoes;
    private javax.swing.JPanel jpConteudo;
    // End of variables declaration//GEN-END:variables

    private void inicializacoesComponentes() {
        
        //painéis
        this.investimentosView = null;
        this.cenariosView = null;
        this.simulacaoView = null;
        
        //janela
        this.setLocationRelativeTo(null);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.setExtendedState(MAXIMIZED_BOTH);
        this.setFontes();
        
        // obtendo a stream para o relatório
        ControleRecursos controleRecursos = new ControleRecursos();
        this.setIconImage(controleRecursos.getIcone(ControleRecursos.IMAGEM.ICONE_PROGRAMA).getImage());
    }
    
    public void setPainelPrincipal(JPanel painel) {
        jpConteudo.removeAll();
        jpConteudo.setLayout(new BorderLayout());
        jpConteudo.add(painel, BorderLayout.CENTER);    
        painel.setVisible(true);
        revalidate();
        repaint();
    }

    private void desalocaCenarioViewAnterior() {
//        implementar alguma função para não deixar multiplos painéis salvos na memória duarante
//        a execução da aplicação
    }

    private void desalocaInvestimentosViewAnterior() {
//        implementar alguma função para não deixar multiplos painéis salvos na memória duarante
//        a execução da aplicação
    }

    private void desalocaSimulacaoViewAnterior() {
//        implementar alguma função para não deixar multiplos painéis salvos na memória duarante
//        a execução da aplicação
    }
}
