/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.util;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

/**
 *
 * @author flavio
 */
public class DocumentGenerico extends PlainDocument{

    public enum TIPO{
        NUMERICO_DECIMAL,
        NUMERICO_INTEIRO,
        LITERAL,
        LIVRE
    }
    
    private Boolean uppercase;
    private TIPO tipo;
    private Integer tamanhoMaximo;   
    
    private void init()
    {
        this.uppercase = false;
        this.tipo = TIPO.LIVRE;
        this.tamanhoMaximo = null;
    }
    
    public DocumentGenerico() {
        super();
    }

    public DocumentGenerico(TIPO tipo) {
        super();
        this.init();
        this.tipo = tipo;
    }
    
    public DocumentGenerico(TIPO tipo, Integer tamanhoMaximo) {
        super();
        this.init();
        this.tipo = tipo;
        this.tamanhoMaximo = tamanhoMaximo;
    }

    public DocumentGenerico(TIPO tipo, Integer tamanhoMaximo, Boolean uppercase) {
        super();
        this.init();
        this.tipo = tipo;
        this.tamanhoMaximo = tamanhoMaximo;
        this.uppercase = uppercase;
    }

    
    @Override
    public void insertString(int offs, String str, AttributeSet a) throws BadLocationException {
        
        boolean canInsert = true;
        
        if(this.tamanhoMaximo != null)
        {
            if(getLength() + str.length() > this.tamanhoMaximo)
            {
                canInsert = false;
            }
        }
        
        if(tipo != TIPO.LIVRE)
        {
            if(tipo == TIPO.LITERAL)
            {
                str = str.replaceAll("[0|1|2|3|4|5|6|7|8|9]", "");
            }
            else if(tipo == TIPO.NUMERICO_INTEIRO)
            {
                str = str.replaceAll("[^0|1|2|3|4|5|6|7|8|9]", "");
            }
            else if(tipo == TIPO.NUMERICO_DECIMAL)
            {
                str = str.replaceAll("[^0|1|2|3|4|5|6|7|8|9|','|'.']", "");
                str = str.replaceAll("[,]", ".");
                
                // obtem o conteudo completo do campo antes da inserção da string analizado
                String strConteudo = getText(0, getLength());
                
                // monta uma palavra adicionando o conteudo que já consta no documento mais o conteudo a ser inserido
                strConteudo = strConteudo + str;
                
                // testa a palavra que será formada caso a inserção do texto a ser inserido seja efetivada, caso ela
                // não forme um double marca o campo canInsert como false, negando a inserção.
                if (!isDouble(strConteudo)) canInsert = false;
            }
        }
        
        if(this.uppercase)
        {
            str = str.toUpperCase();
        }
        
        if(canInsert)
        {
            super.insertString(offs, str, a);
        }
    }
    

    private boolean isDouble(String stringValor) {
        
        try {
            
            Double number = Double.parseDouble(stringValor);
            
            return true;
            
        } catch (NumberFormatException e) {
            return false;
        }
        
    }

//    @Override
//    protected void insertUpdate(DefaultDocumentEvent chng, AttributeSet attr) {
//        super.insertUpdate(chng, attr); //To change body of generated methods, choose Tools | Templates.
//    }
    
}
