/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.flaviobarros.util;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

/**
 *
 * @author flavio
 */
public class DocumentoInteiroGenerico extends PlainDocument {

    private Integer valorMaximo;

    private Integer valorMinimo;

    public DocumentoInteiroGenerico() {
        this.init();
    }

    public DocumentoInteiroGenerico(Integer valorMaximo) {
        this.init();
        this.valorMaximo = valorMaximo;
    }

    public DocumentoInteiroGenerico(Integer valorMaximo, Integer valorMinimo) {
        this.init();
        this.valorMaximo = valorMaximo;
        this.valorMinimo = valorMinimo;
    }

    private void init() {
        this.valorMaximo = null;
        this.valorMinimo = null;
    }

    @Override
    public void insertString(int offs, String str, AttributeSet a) throws BadLocationException {

        boolean canInsert = true;

        str = str.replaceAll("[^0|1|2|3|4|5|6|7|8|9]", "");

        // obtem o conteudo completo do campo antes da inserção da string analizado
        String strConteudo = getText(0, getLength());

        // monta uma palavra adicionando o conteudo que já consta no documento mais o conteudo a ser inserido
        strConteudo = strConteudo.substring(0, offs) + str + strConteudo.substring(offs, strConteudo.length());
        
        // caso o valor inserido seja um inteiro
        if (getInteger(strConteudo) != null) {
            // caso o número a ser inserido ultrapasse o valor máximo
            if (this.valorMaximo != null) {
                if (getInteger(strConteudo) > this.valorMaximo)
                    canInsert = false;
            }

            // caso o número a ser inserido sejá inferior o valor mínimo
            if (this.valorMinimo != null) {
                if (getInteger(strConteudo) < this.valorMinimo)
                    canInsert = false;
            }

        } else {
            canInsert = false;
        }
        
        if (canInsert) {
                super.insertString(offs, str, a);
        }
    }
    
    private Integer getInteger(String stringValor) {

        Integer retorno = null;
        
        try {

            retorno = Integer.parseInt(stringValor);

            return retorno;

        } catch (NumberFormatException e) {
            return retorno;
        }
    }
    

}
